SystemOrganization addCategory: #MetaDDS!
SystemOrganization addCategory: 'MetaDDS-Encoding'!
SystemOrganization addCategory: 'MetaDDS-Kernel'!
SystemOrganization addCategory: 'MetaDDS-Proxy'!
SystemOrganization addCategory: 'MetaDDS-Reflection'!
SystemOrganization addCategory: 'MetaDDS-TypesDefinition'!
SystemOrganization addCategory: 'MetaDDS-TypesMarshalling'!
SystemOrganization addCategory: 'MetaDDS-Util'!

Trait named: #TEquality
	uses: {}
	category: 'MetaDDS-Util'!

!TEquality commentStamp: '<historical>' prior: 0!
TEquality is a trait that provides a generic implementation for = and hash.
It aims avoiding to implement = and hash for simple cases.
To make instances of some class comparable, simply make the class use this trait.

TEquality relies on message valuesToCompareForEquality sent to objects for both = and hash.
The default implmentation of this message is provided by Object.
Override ONLY valuesToCompareForEquality method for custom equality check.!

!TEquality methodsFor: 'comparing' stamp: 'NouryBouraqadi 2/4/2011 23:59'!
= anObject 
	self species = anObject species ifFalse: [^false].
	^self valuesToCompareForEquality = anObject valuesToCompareForEquality! !

!TEquality methodsFor: 'comparing' stamp: 'NouryBouraqadi 8/21/2014 14:01'!
hash
	^self valuesToCompareForEquality inject: self species hash into: [:hash :comparisonValue|
		(hash bitXor: comparisonValue hash) hashMultiply]
! !

!Number methodsFor: '*MetaDDS' stamp: 'SantiagoBragagnolo 9/22/2014 08:42'!
hz
	^ Hz tps: self.! !

Error subclass: #MDDSError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSError commentStamp: 'SantiagoBragagnolo 9/10/2014 23:30' prior: 0!
Project level Error. For specific error management and testing!

!Integer class methodsFor: '*MetaDDS' stamp: 'SantiagoBragagnolo 9/30/2014 12:24'!
fromByteArray: aByteArray 
	^ self byte1: (aByteArray at:1) byte2: (aByteArray at:2) byte3:( aByteArray at:3 )byte4: (aByteArray at:4) .! !

!Integer methodsFor: '*MetaDDS' stamp: 'SantiagoBragagnolo 9/30/2014 12:20'!
bitInvert16
	"Answer the 8-bit complement of the receiver."

	^ self bitXor: 16rFFFF! !

!Integer methodsFor: '*MetaDDS' stamp: 'SantiagoBragagnolo 9/30/2014 12:20'!
bitInvert64
	"Answer the 64-bit complement of the receiver."
	^ self bitXor: 16rFFFFFFFFFFFFFFFF.! !

!Integer methodsFor: '*MetaDDS' stamp: 'SantiagoBragagnolo 9/30/2014 12:20'!
bitInvert8
		^ self bitXor: 16rFF! !

Announcement subclass: #MDDSAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSAnnouncement commentStamp: 'SantiagoBragagnolo 11/19/2014 21:16' prior: 0!
Abstract announcent. It just cuts the default lookup for selectors (check class-side)!

!MDDSAnnouncement class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/19/2014 21:15'!
handlesAnnouncement: anAnnouncement
	" All the inheritance in this hierarchy is for convenience and not for real concept. "
	^ anAnnouncement class == self ! !

MDDSAnnouncement subclass: #MDDSTopicAnnouncement
	instanceVariableNames: 'topic'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSTopicAnnouncement commentStamp: 'SantiagoBragagnolo 10/23/2014 20:55' prior: 0!
Topic are continuously havign changes, new publishers, subscribers, subcriptions, messages. 
Many of the updates are needed by several kinds of objects of different kinds. Then this changes are announced insted of queried.!

MDDSTopicAnnouncement subclass: #MDDSIsPublishingAnnouncement
	instanceVariableNames: 'participant publisher publication'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSIsPublishingAnnouncement commentStamp: 'SantiagoBragagnolo 10/23/2014 20:56' prior: 0!
A MDDSIsPublishingAnnouncement announces that a participant is about to start publishing information in a topic. !

MDDSIsPublishingAnnouncement subclass: #MDDSIsNotPublishingAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSIsNotPublishingAnnouncement commentStamp: 'SantiagoBragagnolo 10/23/2014 20:56' prior: 0!
A MDDSIsNotPublishingAnnouncement announces that a participant closed all relations to the topic as publisher!

!MDDSIsPublishingAnnouncement class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/28/2014 15:14'!
participant: aParticipant publisher: aPublisher publication: aPublication
	^ (self topic: aPublisher topic) participant: aParticipant; publisher: aPublisher; publication: aPublication; yourself.! !

!MDDSIsPublishingAnnouncement methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/23/2014 20:51'!
participant
	^ participant! !

!MDDSIsPublishingAnnouncement methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/23/2014 20:51'!
participant: anObject
	participant := anObject! !

!MDDSIsPublishingAnnouncement methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/28/2014 15:13'!
publication
	^ publication! !

!MDDSIsPublishingAnnouncement methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/28/2014 15:13'!
publication: anObject
	publication := anObject! !

!MDDSIsPublishingAnnouncement methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/23/2014 20:51'!
publisher
	^ publisher! !

!MDDSIsPublishingAnnouncement methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/23/2014 20:51'!
publisher: anObject
	publisher := anObject! !

MDDSTopicAnnouncement subclass: #MDDSIsSubscribedAnnouncement
	instanceVariableNames: 'participant subscriber subscription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSIsSubscribedAnnouncement commentStamp: 'SantiagoBragagnolo 10/23/2014 20:57' prior: 0!
A MDDSIsSubscribedAnnouncement announces that a participant is ready to start publishing receiving information of a particular topic!

MDDSIsSubscribedAnnouncement subclass: #MDDSIsNotSubscribedAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSIsNotSubscribedAnnouncement commentStamp: 'SantiagoBragagnolo 10/23/2014 20:57' prior: 0!
A MDDSIsNotSubscribedAnnouncement  announces that a participant is not interested anymore in a particular topic !

!MDDSIsSubscribedAnnouncement class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/23/2014 21:00'!
participant: aParticipant subscriber: aSubscriber
	^ (self topic: aSubscriber topic) participant: aParticipant; subscriber: aSubscriber; yourself.! !

!MDDSIsSubscribedAnnouncement class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/28/2014 15:15'!
participant: aParticipant subscriber: aSubscriber subscription: aSubscription
	^ (self topic: aSubscriber topic) participant: aParticipant; subscriber: aSubscriber; subscription: aSubscription; yourself.! !

!MDDSIsSubscribedAnnouncement methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/23/2014 20:53'!
participant
	^ participant! !

!MDDSIsSubscribedAnnouncement methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/23/2014 20:53'!
participant: anObject
	participant := anObject! !

!MDDSIsSubscribedAnnouncement methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/23/2014 20:53'!
subscriber
	^ subscriber! !

!MDDSIsSubscribedAnnouncement methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/23/2014 20:53'!
subscriber: anObject
	subscriber := anObject! !

!MDDSIsSubscribedAnnouncement methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/28/2014 15:13'!
subscription
	^ subscription! !

!MDDSIsSubscribedAnnouncement methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/28/2014 15:13'!
subscription: anObject
	subscription := anObject! !

!MDDSTopicAnnouncement class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/28/2014 15:14'!
participant: aParticipant isNotPublishingAnymoreOn: aPublisher through: aPublication
	^ MDDSIsNotPublishingAnnouncement participant: aParticipant publisher: aPublisher publication: aPublication.
	! !

!MDDSTopicAnnouncement class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/28/2014 15:17'!
participant: aParticipant isNotSubscribedAnymoreTo: aSubscriber with: aSubscription
	^ MDDSIsNotSubscribedAnnouncement participant: aParticipant subscriber: aSubscriber subscription: aSubscription! !

!MDDSTopicAnnouncement class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/28/2014 15:16'!
participant: aParticipant isNowPublishingOn: aPublisher through: aPublication
	^ MDDSIsPublishingAnnouncement participant: aParticipant publisher: aPublisher publication: aPublication.! !

!MDDSTopicAnnouncement class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/28/2014 15:17'!
participant: aParticipant isNowSubscribedTo: aSubscriber with: aSubscription
	^ MDDSIsSubscribedAnnouncement participant: aParticipant subscriber: aSubscriber subscription: aSubscription! !

!MDDSTopicAnnouncement class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/23/2014 20:59'!
topic: aTopic
	^ self new topic: aTopic; yourself! !

!MDDSTopicAnnouncement methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/23/2014 20:51'!
topic
	^ topic! !

!MDDSTopicAnnouncement methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/23/2014 20:51'!
topic: anObject
	topic := anObject! !

!Float class methodsFor: '*MetaDDS' stamp: 'SantiagoBragagnolo 9/30/2014 12:13'!
fromIEEE32BitByteArray: aByteArray 
	^ self fromIEEE32Bit: (LargePositiveInteger fromByteArray: aByteArray ).! !

!Duration methodsFor: '*MetaDDS' stamp: 'SantiagoBragagnolo 9/30/2014 12:26'!
nanoSecondsField 
	^nanos.! !

!Duration methodsFor: '*MetaDDS' stamp: 'SantiagoBragagnolo 9/30/2014 12:26'!
secondsField 
	^seconds ! !

!ProtoObject class methodsFor: '*MetaDDS' stamp: 'NouryBouraqadi 8/21/2014 14:53'!
allInstVarNamesForEqualityComparison
	^#()! !

Object subclass: #Hz
	instanceVariableNames: 'timesPerSecond'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Util'!

!Hz commentStamp: 'SantiagoBragagnolo 9/27/2014 19:32' prior: 0!
A Hz is neasure that represents times per seconds!

!Hz class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/22/2014 08:41'!
tps: aNumber
	^ self new timesPerSecond: aNumber; yourself! !

!Hz methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/22/2014 08:43'!
cycle
	^ (1 / timesPerSecond) asSeconds. ! !

!Hz methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/22/2014 08:45'!
cycleDelay
	^ self cycle asDelay.! !

!Hz methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/22/2014 08:38'!
timesPerSecond: aNumber
	timesPerSecond  := aNumber! !

Object subclass: #MDDSAbstractDTO
	instanceVariableNames: 'values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSAbstractDTO commentStamp: '<historical>' prior: 0!
A PhaROSValue is a Value that has it definition in a dictionary. Is used as super class of all the generated classes related with  types.!

!MDDSAbstractDTO methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:08'!
asString
	| string |
	string := self class name , '>>' , String crlf , String tab.
	values keysAndValuesDo: [ :key :val | string := string , key asString , ':' , val asString , ' | ' ].
	string := string , String crlf.
	^ string! !

!MDDSAbstractDTO methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/3/2012 13:00'!
at:aName put: aValue
	values at:aName put: aValue.! !

!MDDSAbstractDTO methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:08'!
closeTo: anOtherValue
	^ self class = anOtherValue class
		and: [
			
			| allSatisfy |
			allSatisfy := true.
			values keysAndValuesDo: [ :key :val | allSatisfy := allSatisfy and: [ val closeTo: (anOtherValue getAt: key) ] ].
			allSatisfy
			]! !

!MDDSAbstractDTO methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/3/2012 13:00'!
getAt:aName 
	^ values at: aName.! !

!MDDSAbstractDTO methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 1/23/2013 21:48'!
hasAttribute: aName 
	^ values includesKey: aName.! !

!MDDSAbstractDTO methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/3/2012 13:00'!
initialize 
	values := Dictionary new.
	! !

!MDDSAbstractDTO methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 1/23/2013 21:28'!
isBasic
	^ false. ! !

!MDDSAbstractDTO methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/8/2012 16:31'!
printOn: aStream
	aStream nextPutAll: self asString.
	! !

MDDSAbstractDTO subclass: #MDDSHandshakeHeader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSHandshakeHeader commentStamp: 'SantiagoBragagnolo 10/6/2014 18:36' prior: 0!
This header is specific for topic handshake it may have to many things from ROS needs, but time will tell us more about this. !

!MDDSHandshakeHeader methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:09'!
= anOtherHeader
	^ (anOtherHeader isKindOf: MDDSHandshakeHeader) and: [ self attributes asSet = anOtherHeader attributes asSet ]! !

!MDDSHandshakeHeader methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:09'!
asString
	^ self attributes inject: '****** header ******' into: [ :acc :each | acc , String lf , each asString ]! !

!MDDSHandshakeHeader methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:09'!
attribute: aName
	^ self attributes detect: [ :attr | attr name = aName ] ifNone: nil! !

!MDDSHandshakeHeader methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/20/2014 22:09'!
attributes
	^ self getAt: #attributes! !

!MDDSHandshakeHeader methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/20/2014 22:09'!
attributes: aValue
	^ self at: #attributes put: aValue! !

!MDDSHandshakeHeader methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/20/2014 22:09'!
callerId: aValue
	self attributes add: (MDDSHeaderAtribute name: 'callerid' value: aValue)! !

!MDDSHandshakeHeader methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:09'!
initialize
	super initialize.
	self attributes: OrderedCollection new! !

!MDDSHandshakeHeader methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:09'!
latching
	^ (self attribute: 'latching') value! !

!MDDSHandshakeHeader methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/17/2014 15:52'!
latching: aValue
	(self attribute: 'latching')
		ifNil: [ self attributes add: (MDDSHeaderAtribute name: 'latching' value: aValue) ]
		ifNotNil: [ :val | val value: aValue ]! !

!MDDSHandshakeHeader methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/18/2014 16:02'!
loadFrom: aConnectionPetition
	self
		callerId: aConnectionPetition participant name;
		latching: aConnectionPetition latching;
		topic: aConnectionPetition topic name;
		type: aConnectionPetition topic type name;
		md5sum: aConnectionPetition topic type md5sum;
		message_definition: aConnectionPetition topic type plainDefinition! !

!MDDSHandshakeHeader methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/17/2014 15:49'!
md5sum
	^ (self attribute: 'md5sum') value.! !

!MDDSHandshakeHeader methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/17/2014 15:52'!
md5sum: aValue
	(self attribute: 'md5sum')
		ifNil: [ self attributes add: (MDDSHeaderAtribute name: 'md5sum' value: aValue) ]
		ifNotNil: [ :val | val value: aValue ]! !

!MDDSHandshakeHeader methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/18/2014 23:19'!
message_definition
	^ (self attribute: 'message_definition') value.! !

!MDDSHandshakeHeader methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/20/2014 22:09'!
message_definition: aValue
	self attributes add: (MDDSHeaderAtribute name: 'message_definition' value: aValue)! !

!MDDSHandshakeHeader methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/1/2014 14:30'!
printOn: aStream
	self asString printOn: aStream! !

!MDDSHandshakeHeader methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/17/2014 15:49'!
topic
	^ (self attribute: 'topic') value! !

!MDDSHandshakeHeader methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/17/2014 15:53'!
topic: aValue
	(self attribute: 'topic')
		ifNil: [ self attributes add: (MDDSHeaderAtribute name: 'topic' value: aValue) ]
		ifNotNil: [ :val | val value: aValue ]! !

!MDDSHandshakeHeader methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/17/2014 15:49'!
type
	^ (self attribute: 'type') value.! !

!MDDSHandshakeHeader methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/17/2014 15:54'!
type: aValue
	(self attribute: 'type')
		ifNil: [ self attributes add: (MDDSHeaderAtribute name: 'type' value: aValue) ]
		ifNotNil: [ :val | val value: aValue ]! !

Object subclass: #MDDSAbstractDomainProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Proxy'!

!MDDSAbstractDomainProxy commentStamp: 'SantiagoBragagnolo 9/15/2014 19:32' prior: 0!
All remote domain mirrors are related with a proxy. This proxy is meant to be a proxy  adaptor. The idea is to subclass this class, and use a proxy. The used proxy can have what ever it takes and needs to implement the comunicaiton. Meanwhile the adapter proxy(subclass) needs to respond to a known protocol.!

!MDDSAbstractDomainProxy methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/13/2014 20:03'!
createPublicationFor: aMDDSDomainParticipant with: aType
	^ self subclassResponsibility ! !

!MDDSAbstractDomainProxy methodsFor: 'abstract' stamp: 'SantiagoBragagnolo 11/28/2014 14:35'!
destroy
	" nothing to do here "
	! !

!MDDSAbstractDomainProxy methodsFor: 'abstract' stamp: 'SantiagoBragagnolo 11/14/2014 14:36'!
loadTypeDefinitionNamed: aName definedFromString: aStringDefinition
	self subclassResponsibility .! !

!MDDSAbstractDomainProxy methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/4/2014 19:41'!
obtainPort
	self subclassResponsibility ! !

!MDDSAbstractDomainProxy methodsFor: 'abstract' stamp: 'SantiagoBragagnolo 2/8/2015 12:48'!
participants
	self subclassResponsibility ! !

!MDDSAbstractDomainProxy methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/18/2014 16:06'!
plainTypeDefinitionFor: aType! !

!MDDSAbstractDomainProxy methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/12/2014 20:01'!
reflectParticipant: aMDDSParticipant
	self subclassResponsibility ! !

!MDDSAbstractDomainProxy methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/7/2014 13:59'!
registerTopicPublisher: aPublisher for: aParticipant in: aDomain
	self subclassResponsibility ! !

!MDDSAbstractDomainProxy methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/22/2014 23:20'!
registerTopicSubscriber: aSubscriber for: aParticipant in: aDomain
	self subclassResponsibility ! !

!MDDSAbstractDomainProxy methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/21/2014 20:47'!
subscriberFor: aTopic in: aDomain
	self subclassResponsibility ! !

!MDDSAbstractDomainProxy methodsFor: 'abstract' stamp: 'SantiagoBragagnolo 9/10/2014 20:20'!
topics
	self subclassResponsibility ! !

!MDDSAbstractDomainProxy methodsFor: 'abstract' stamp: 'SantiagoBragagnolo 11/19/2014 12:22'!
typeDefinition: aString 
	^ self typeDefinition: aString  ifAbsent: [ self error: 'There is not type named ', aString ]! !

!MDDSAbstractDomainProxy methodsFor: 'abstract' stamp: 'SantiagoBragagnolo 11/19/2014 12:22'!
typeDefinition: aString ifAbsent: aBlock
	^ self subclassResponsibility ! !

!MDDSAbstractDomainProxy methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/7/2014 13:59'!
unregisterTopicPublisher: aPublisher for: aParticipant
	self subclassResponsibility ! !

!MDDSAbstractDomainProxy methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/15/2014 19:06'!
unregisterTopicSubscriber: aSubscriber for: aParticipant
	self subclassResponsibility ! !

Object subclass: #MDDSAbstractParticipantProxy
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Proxy'!

!MDDSAbstractParticipantProxy commentStamp: 'SantiagoBragagnolo 9/15/2014 19:32' prior: 0!
All remote participant mirrors are related with a proxy. This proxy is meant to be a proxy  adaptor. The idea is to subclass this class, and use a proxy. The used proxy can have what ever it takes and needs to implement the comunicaiton. Meanwhile the adapter proxy(subclass) needs to respond to a known protocol.!

!MDDSAbstractParticipantProxy methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 2/8/2015 12:45'!
name
	^ name! !

!MDDSAbstractParticipantProxy methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 2/8/2015 12:45'!
name: aName
	name := aName! !

!MDDSAbstractParticipantProxy methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 2/8/2015 12:47'!
printOn: aStream
	(' Proxy to ', name) printOn: aStream! !

Object subclass: #MDDSBaseTypeMarshaller
	instanceVariableNames: 'encodeSelector decodeSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-TypesMarshalling'!

!MDDSBaseTypeMarshaller commentStamp: '<historical>' prior: 0!
A PhaROSType is abstract representation of type!

!MDDSBaseTypeMarshaller class methodsFor: 'pseudo-dsl' stamp: 'SantiagoBragagnolo 9/30/2014 11:20'!
constant: aTypeName value: aValue 
	^ MDDSConstantDefinition name: aTypeName typedAs: self new withValue: aValue.! !

!MDDSBaseTypeMarshaller class methodsFor: 'private' stamp: 'SantiagoBragagnolo 9/16/2014 20:40'!
forPhaROSTyping
	^ self! !

!MDDSBaseTypeMarshaller class methodsFor: 'pseudo-dsl' stamp: 'SantiagoBragagnolo 10/3/2014 15:48'!
initialize 	
	super initialize.
	self = MDDSBaseTypeMarshaller ifFalse: [
		self registerAlterName.
	]! !

!MDDSBaseTypeMarshaller class methodsFor: 'pseudo-dsl' stamp: 'SantiagoBragagnolo 9/16/2014 20:40'!
registerAlterName
	Smalltalk at: self alterName put: self.! !

!MDDSBaseTypeMarshaller methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 1/23/2013 19:48'!
check: aValue

	(self isAPossibleValue: aValue ) ifFalse:[ PhaROSUnexpextedValue signal: 'Unexpected value'].! !

!MDDSBaseTypeMarshaller methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 2/21/2013 11:50'!
constantValue: aValue
	^ aValue.! !

!MDDSBaseTypeMarshaller methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/28/2012 16:46'!
dataTypeSize
	^ self class dataTypeSize.! !

!MDDSBaseTypeMarshaller methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/9/2012 13:45'!
dataTypeSizeFor: aValue
	^ self dataTypeSize.! !

!MDDSBaseTypeMarshaller methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/9/2012 12:20'!
decode: aDecoder

	^ aDecoder perform: decodeSelector.! !

!MDDSBaseTypeMarshaller methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/9/2012 12:22'!
decodeSelector 
	^decodeSelector.! !

!MDDSBaseTypeMarshaller methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/3/2012 15:19'!
defaultValueString
	^ self newInstance asString.! !

!MDDSBaseTypeMarshaller methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/9/2012 12:22'!
encodeSelector 
	^ encodeSelector.! !

!MDDSBaseTypeMarshaller methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/9/2012 12:21'!
initialize 
	self setEncodeDecodeSelectors.! !

!MDDSBaseTypeMarshaller methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 1/23/2013 21:51'!
isAPossibleSize: aSize
	^ aSize = self dataTypeSize.! !

!MDDSBaseTypeMarshaller methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 11/15/2012 15:47'!
isCollectionType
	^ false! !

!MDDSBaseTypeMarshaller methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/10/2012 13:47'!
newInstance
	^ Array new.! !

!MDDSBaseTypeMarshaller methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 11/6/2012 11:13'!
newPacket
	^ PhaROSPacket type: self value: self newInstance.! !

!MDDSBaseTypeMarshaller methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/9/2012 12:24'!
serialize:aValue into: anEncoder
	^ anEncoder perform: encodeSelector with: aValue.! !

!MDDSBaseTypeMarshaller methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 5/28/2013 13:40'!
typeName
	^ self subclassResponsibility ! !

!MDDSBaseTypeMarshaller methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/15/2014 20:09'!
unserialize: aStream
	| decoder aByteArray | 
	
	aByteArray  := aStream next: self dataTypeSize.
	
	aByteArray size = self dataTypeSize ifFalse: [
		PhaROSUnexpextedValue signal:' Unexpected Value'.
	].

	decoder := MDDSDecoder on: (ReadStream on: aByteArray).
	self decode: decoder. 
	
	! !

MDDSBaseTypeMarshaller subclass: #MDDSBoolType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-TypesMarshalling'!

!MDDSBoolType commentStamp: '<historical>' prior: 0!
A PhaROSBoolType is a bool type. !

!MDDSBoolType class methodsFor: 'pseudo-dsl' stamp: 'SantiagoBragagnolo 9/16/2014 20:40'!
alterName
	^ #Bool! !

!MDDSBoolType class methodsFor: 'serialize' stamp: 'SantiagoBragagnolo 9/16/2014 20:40'!
dataTypeSize 
	^ 1! !

!MDDSBoolType class methodsFor: 'serialize' stamp: 'SantiagoBragagnolo 9/16/2014 20:40'!
unserialize: aByteArray 
	self shouldBeImplemented.! !

!MDDSBoolType methodsFor: 'serialize' stamp: 'SantiagoBragagnolo 1/22/2014 12:19'!
decode: aFLDecoder 
	| val |	
	val := aFLDecoder nextEncodedByte.
	val = 0 ifTrue: [
		^ false.	
	].
	val = 1 ifTrue: [
		^ true.	
	].
	
	self signal: 'Unexpected value'.! !

!MDDSBoolType methodsFor: 'serialize' stamp: 'SantiagoBragagnolo 10/3/2012 17:56'!
isAPossibleValue: aBoolean
	^ aBoolean = true or: [ aBoolean = false ]! !

!MDDSBoolType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/3/2012 14:26'!
newInstance 
	^ false.! !

!MDDSBoolType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/9/2012 12:26'!
setEncodeDecodeSelectors 
	decodeSelector := #nextEncodedBoolean.
	encodeSelector := #encodeBoolean:.
	! !

!MDDSBoolType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/28/2013 13:41'!
typeName
	^ 'bool'! !

MDDSBaseTypeMarshaller subclass: #MDDSCollectionType
	instanceVariableNames: 'relatedClass relatedType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-TypesMarshalling'!

!MDDSCollectionType commentStamp: '<historical>' prior: 0!
A PhaROSCollectionType is an abstract representation of collections type!

MDDSCollectionType subclass: #MDDSArrayFixedLenghtType
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-TypesMarshalling'!

!MDDSArrayFixedLenghtType commentStamp: '<historical>' prior: 0!
A PhaROSArrayFixedLenghtType is a type of fixed lenght and fixed type!

!MDDSArrayFixedLenghtType class methodsFor: 'pseudo-dsl' stamp: 'SantiagoBragagnolo 9/16/2014 20:40'!
alterName
	^ #FixedArray! !

!MDDSArrayFixedLenghtType class methodsFor: 'pseudo-dsl' stamp: 'SantiagoBragagnolo 9/16/2014 20:40'!
named: aName
	self error: 'Fixed array need more than just name. Use #named:sized:ofType: instead'! !

!MDDSArrayFixedLenghtType class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/16/2014 20:40'!
of: aSize of: aClass
	^ self new size: aSize; ofClass: aClass; yourself .! !

!MDDSArrayFixedLenghtType class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/26/2014 12:02'!
sized: aSize
	^ self new
		size: aSize;
		yourself! !

!MDDSArrayFixedLenghtType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 12/10/2012 17:07'!
defaultValueString 
	^ ' (OrderedCollection new: ' , size asString, ')'.
	! !

!MDDSArrayFixedLenghtType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 2/8/2013 17:02'!
isAPossibleValue: aValue
	^ (super isAPossibleValue: aValue ) and: [ aValue size = size asNumber ].! !

!MDDSArrayFixedLenghtType methodsFor: 'as yet unclassified' stamp: 'janniklaval 12/11/2012 08:09'!
serialize:aValue into: anEncoder
	^ anEncoder encodeFixedLenghtArray: aValue of: self relatedType.
! !

!MDDSArrayFixedLenghtType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 2/8/2013 17:00'!
size: aSize
	size := aSize asNumber.! !

!MDDSArrayFixedLenghtType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/10/2012 15:28'!
sizeFor: aDecoder 
	^ size.! !

!MDDSArrayFixedLenghtType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/28/2013 13:47'!
typeName
	^ relatedType typeName, ('[{1}] ' format: { size })! !

MDDSCollectionType subclass: #MDDSArrayType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-TypesMarshalling'!

!MDDSArrayType commentStamp: '<historical>' prior: 0!
A PhaROSArrayType is an array of variable length and fixed type.!

!MDDSArrayType class methodsFor: 'pseudo-dsl' stamp: 'SantiagoBragagnolo 9/16/2014 20:41'!
named: aName
	self error: 'Array need more than just name. Use #named:ofType: instead'! !

!MDDSArrayType class methodsFor: 'construction' stamp: 'SantiagoBragagnolo 9/16/2014 20:41'!
of: aClass
	^ self new ofClass: aClass; yourself .! !

!MDDSArrayType class methodsFor: 'pseudo-dsl' stamp: 'SantiagoBragagnolo 9/16/2014 20:41'!
registerAlterName
	" Name collision. DSL constructor name is at Array class as extention method "! !

!MDDSArrayType methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 2/27/2013 12:34'!
dataTypeSize
	^(1024*1024*10).
"
	self error: 'You need to specify the related value to this kind of array'."! !

!MDDSArrayType methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/10/2012 15:14'!
dataTypeSizeFor: aValue
	^ (super dataTypeSizeFor: aValue )+ 4.! !

!MDDSArrayType methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 11/15/2012 17:27'!
defaultValueString 
	^ 'OrderedCollection new '.
	! !

!MDDSArrayType methodsFor: 'initialize' stamp: 'SantiagoBragagnolo 10/10/2012 12:52'!
newInstance 
	^ {}.! !

!MDDSArrayType methodsFor: 'initialize' stamp: 'SantiagoBragagnolo 11/27/2012 17:34'!
serialize:aValue into: anEncoder
	^ anEncoder encodeArray: aValue of: self relatedType.
! !

!MDDSArrayType methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/10/2012 15:28'!
sizeFor: aDecoder 
	^ aDecoder nextEncodedUint32.! !

!MDDSArrayType methodsFor: 'initialize' stamp: 'SantiagoBragagnolo 2/13/2015 22:12'!
typeName
	^ (relatedType ifNil: [ '?' ] ifNotNil: [ :t | t typeName ]) , '[]'! !

!MDDSCollectionType class methodsFor: 'pseudo-dsl' stamp: 'SantiagoBragagnolo 11/26/2014 11:03'!
registerAlterName
	" This is an abstract class. Does not apply "
	self = MDDSCollectionType ifFalse: [ 
		super registerAlterName.
	 ]! !

!MDDSCollectionType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/26/2014 11:49'!
dataTypeSizeFor: aValue
self flag: #cambiarEstooo. " "

	(self isAPossibleValue: aValue ) ifFalse: [
		MDDSError signal: 'Unexpected value'.
	].
	
	^(aValue inject: 0 into:[
		:acc :val | 
		acc + (self  relatedType dataTypeSizeFor: val ).
	]).! !

!MDDSCollectionType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/10/2012 15:27'!
decode: aDecoder 
	^ (1 to: (self sizeFor: aDecoder ) ) collect: [
		:i |
		self relatedType decode: aDecoder.
	] .! !

!MDDSCollectionType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/10/2012 15:29'!
isAPossibleSize: aSize
	^ aSize > 0.! !

!MDDSCollectionType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 12/17/2012 15:10'!
isAPossibleValue: aValue
	^( aValue isKindOf: Collection ) and: [
		aValue allSatisfy: [
			:val |
			self relatedType isAPossibleValue: val.
		]	
	].! !

!MDDSCollectionType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/15/2012 15:47'!
isCollectionType
	^ true! !

!MDDSCollectionType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/10/2012 15:25'!
ofClass: aRosTypeClass
	relatedClass := aRosTypeClass.! !

!MDDSCollectionType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/27/2012 15:48'!
ofType: aRosType
	relatedType  := aRosType.
	relatedClass := aRosType class.! !

!MDDSCollectionType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/10/2012 15:25'!
relatedType
	^ relatedType ifNil: [ relatedType := relatedClass new ].! !

!MDDSCollectionType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 12/21/2012 10:08'!
relatedType: aType
	relatedType := aType.
	relatedClass := aType class.
	! !

!MDDSCollectionType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/10/2012 15:44'!
setEncodeDecodeSelectors
	" Refactor needed here ."
	encodeSelector := #doesNotApplyHere.
	decodeSelector := #doesNotApplyHere.! !

!MDDSCollectionType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/10/2012 15:27'!
sizeFor: aDecoder 
	^ self subclassResponsibility.! !

MDDSBaseTypeMarshaller subclass: #MDDSCompositeType
	instanceVariableNames: 'typeName typeDefinition relatedClass md5Sum constants'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-TypesMarshalling'!

MDDSCompositeType class
	instanceVariableNames: 'types'!

!MDDSCompositeType commentStamp: '<historical>' prior: 0!
A PhaROSCompositeType is a composition of basic types. Defining this way structures!

MDDSCompositeType class
	instanceVariableNames: 'types'!

!MDDSCompositeType class methodsFor: 'construction' stamp: 'SantiagoBragagnolo 9/19/2014 19:11'!
named: aByteString
	
	^ super new typeName: aByteString ; yourself! !

!MDDSCompositeType class methodsFor: 'construction' stamp: 'SantiagoBragagnolo 9/16/2014 20:41'!
named: aByteString definedBy: anArray withConstants: aConstantsArray.
	^ (self named: aByteString) useTypeDefinition:  anArray ; useConstants: aConstantsArray yourself.! !

!MDDSCompositeType class methodsFor: 'construction' stamp: 'SantiagoBragagnolo 9/16/2014 20:41'!
new
	self error: 'You must use at least #named: construction method'.! !

!MDDSCompositeType class methodsFor: 'pseudo-dsl' stamp: 'SantiagoBragagnolo 9/16/2014 20:41'!
registerAlterName 
	"Do not apply"! !

!MDDSCompositeType methodsFor: 'serializing' stamp: 'SantiagoBragagnolo 2/21/2013 11:25'!
constants 
	^ constants ifNil: [ constants := Dictionary new ].! !

!MDDSCompositeType methodsFor: 'serializing' stamp: 'SantiagoBragagnolo 1/23/2013 21:54'!
dataTypeSize
	"beware of recursive structures!!"
	
	^ typeDefinition values inject:0 into:[ :acc :t | acc + t dataTypeSize ].! !

!MDDSCompositeType methodsFor: 'serializing' stamp: 'SantiagoBragagnolo 11/27/2012 14:55'!
dataTypeSizeFor: aValue 
	"beware of recursive structures!!"
	| acc |
	acc := 0.
	
	typeDefinition keysAndValuesDo:[ :attributeName :type |
			acc := acc + (type dataTypeSizeFor: (aValue perform: attributeName asSymbol)).
	 ].

	^ acc.! !

!MDDSCompositeType methodsFor: 'serializing' stamp: 'SantiagoBragagnolo 10/3/2012 16:37'!
decode: aFLDecoder 
	| instance |
	instance := self relatedClass new.
	self typeDefinition keysAndValuesDo:  [ :name :type |
		instance at: name put: (type decode: aFLDecoder).
	].
	^ instance.! !

!MDDSCompositeType methodsFor: 'serializing' stamp: 'SantiagoBragagnolo 2/10/2014 10:27'!
defaultValueString
	 ^ relatedClass name , ' new'


! !

!MDDSCompositeType methodsFor: 'deploying' stamp: 'SantiagoBragagnolo 1/2/2014 17:58'!
dependencies 

	| return packageName packageNameType |
	
	"
		dependencies are related with the package owner of each type. 
		The dependencies exists if the type related with the type is package type (std_msg/Int32 by example.) but no the basic types as Int32 it self. Check more in the type definition in the documentation of ROS
		
		int32 val
		std_msgs/Header
		
		int this case, int32 does not imply any dependency, but Header indeed it mean it. 
	"
	
	return := Set new.
	packageName := (( '/' split: self typeName ) at: 1).
	
	typeDefinition keysAndValuesDo: [:k :v | 
		 packageNameType := ( '/' split: v typeName ) .
		packageNameType size > 1 ifTrue: [
			packageNameType := packageNameType at:1 .
			packageNameType = packageName ifFalse: [
				return add: packageNameType.
		 	].		
		]
	].
	^ return.
! !

!MDDSCompositeType methodsFor: 'serializing' stamp: 'SantiagoBragagnolo 10/10/2012 16:49'!
doItSilently: aBlock
	aBlock value.
! !

!MDDSCompositeType methodsFor: 'initialize-release' stamp: 'SantiagoBragagnolo 2/21/2013 11:14'!
initialize 
	"attribute's name  => attribute's type"
	typeDefinition := OrderPreservingDictionary new.
	constants := Dictionary new.! !

!MDDSCompositeType methodsFor: 'serializing' stamp: 'PhaROS 11/28/2013 18:41'!
isAPossibleSize: aSize
	^ true.! !

!MDDSCompositeType methodsFor: 'serializing' stamp: 'SantiagoBragagnolo 1/23/2013 21:29'!
isAPossibleValue: aValue
	^ aValue isBasic not.! !

!MDDSCompositeType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 1/16/2014 15:17'!
isZeroSized
	^ typeDefinition size = 0! !

!MDDSCompositeType methodsFor: 'serializing' stamp: 'SantiagoBragagnolo 2/12/2013 14:48'!
md5Sum 

	md5Sum ifNil: [
		md5Sum:= PhaROSTypeBrowser instance md5Sum: typeName.
	].
	^ md5Sum! !

!MDDSCompositeType methodsFor: 'serializing' stamp: 'SantiagoBragagnolo 12/20/2012 17:33'!
new 
	^ self.! !

!MDDSCompositeType methodsFor: 'serializing' stamp: 'SantiagoBragagnolo 10/3/2012 14:33'!
newInstance 
	^ self relatedClass new.! !

!MDDSCompositeType methodsFor: 'serializing' stamp: 'SantiagoBragagnolo 2/8/2014 17:45'!
relatedClass
	^ relatedClass! !

!MDDSCompositeType methodsFor: 'serializing' stamp: 'SantiagoBragagnolo 2/8/2014 17:44'!
relatedClass: aClass
	relatedClass := aClass.! !

!MDDSCompositeType methodsFor: 'serializing' stamp: 'SantiagoBragagnolo 10/1/2014 15:59'!
serialize:aValue into: aFLEncoder 
	^ self typeDefinition keysAndValuesDo:  [ :name :type |
		type serialize: (aValue getAt: name) into: aFLEncoder.
	].
	
! !

!MDDSCompositeType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/9/2012 12:27'!
setEncodeDecodeSelectors 
	! !

!MDDSCompositeType methodsFor: 'serializing' stamp: 'SantiagoBragagnolo 10/3/2012 12:36'!
typeDefinition 
	^typeDefinition ! !

!MDDSCompositeType methodsFor: 'serializing' stamp: 'SantiagoBragagnolo 10/3/2012 15:40'!
typeName 
	^typeName.! !

!MDDSCompositeType methodsFor: 'serializing' stamp: 'SantiagoBragagnolo 10/3/2012 15:40'!
typeName: aTypeName
	typeName := aTypeName.! !

!MDDSCompositeType methodsFor: 'initialize-release' stamp: 'SantiagoBragagnolo 2/9/2014 16:47'!
useConstants: aConstantsArray 
	aConstantsArray do: [ : constant |
		self constants at: constant name put: constant value.
	]
	! !

!MDDSCompositeType methodsFor: 'initialize-release' stamp: 'SantiagoBragagnolo 9/30/2014 23:40'!
useTypeDefinition: anArrayOfFields
	anArrayOfFields do: [ : field |
		
		typeDefinition at: field name put: field type.
	]
	! !

MDDSBaseTypeMarshaller subclass: #MDDSDurationType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-TypesMarshalling'!

!MDDSDurationType commentStamp: '<historical>' prior: 0!
A PhaROSDurationType is type that represents interval  of time!

!MDDSDurationType class methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/16/2014 20:41'!
dataTypeSize
	^ 8! !

!MDDSDurationType class methodsFor: 'pseudo-dsl' stamp: 'SantiagoBragagnolo 9/16/2014 20:41'!
registerAlterName
	" Name collision. DSL constructor name is at Duration class as extention method "! !

!MDDSDurationType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/10/2012 12:18'!
defaultValueString
	^ ' Duration seconds: 0'. ! !

!MDDSDurationType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/10/2012 12:23'!
isAPossibleValue: aDuration
	^ (aDuration isKindOf: Duration) and: [
		aDuration secondsField  < 4294967296 and: [
			aDuration nanoSecondsField  < 4294967296 
		]
	].! !

!MDDSDurationType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/10/2012 12:18'!
newInstance 
	^ Duration new. ! !

!MDDSDurationType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/10/2012 12:19'!
setEncodeDecodeSelectors
	encodeSelector := #encodeDuration:.
	decodeSelector := #nextEncodedDuration.! !

!MDDSDurationType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/28/2013 13:42'!
typeName 
	^ 'duration'! !

MDDSBaseTypeMarshaller subclass: #MDDSFloat32Type
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-TypesMarshalling'!

!MDDSFloat32Type commentStamp: '<historical>' prior: 0!
A PhaROSFloat32Type is Float 32 bits type!

!MDDSFloat32Type class methodsFor: 'pseudo-dsl' stamp: 'SantiagoBragagnolo 9/16/2014 20:41'!
alterName
	^ #Float32! !

!MDDSFloat32Type class methodsFor: 'construction' stamp: 'SantiagoBragagnolo 9/16/2014 20:41'!
dataTypeSize
	^ 4! !

!MDDSFloat32Type methodsFor: 'serialize' stamp: 'SantiagoBragagnolo 10/9/2012 11:45'!
decode: aFLDecoder 
	^ aFLDecoder nextEncodedFloat32.! !

!MDDSFloat32Type methodsFor: 'testing' stamp: 'SantiagoBragagnolo 9/15/2014 20:09'!
isAPossibleValue: aFloat 
	| float32 |
	
	(aFloat isKindOf: Number) ifFalse: [ ^ false. ] .

	float32 := (aFloat asFloat roundUpTo: 0.0001) truncateTo: 0.01.
	
	^(float32  isKindOf: Float) and: [
		float32  = 0 or: [
			| encoder decoder stream |
			stream := WriteStream on: (ByteArray new: 4).
			encoder := MDDSEncoder on:stream .
			encoder encodefloat32: float32 .
			encoder flush.
			stream := ReadStream on: stream contents.
			decoder := MDDSDecoder on: stream.
			
			(float32 abs - decoder nextEncodedFloat32 abs) abs < 0.01 
		].
	]! !

!MDDSFloat32Type methodsFor: 'serialize' stamp: 'SantiagoBragagnolo 10/3/2012 14:26'!
newInstance 
	^ 0.0.! !

!MDDSFloat32Type methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/9/2012 12:27'!
setEncodeDecodeSelectors 
	decodeSelector := #nextEncodedFloat32.
	encodeSelector := #encodefloat32:.
	 ! !

!MDDSFloat32Type methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/28/2013 13:43'!
typeName 
	^ 'float32'! !

MDDSBaseTypeMarshaller subclass: #MDDSFloat64Type
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-TypesMarshalling'!

!MDDSFloat64Type commentStamp: '<historical>' prior: 0!
A PhaROSFloat64Type is Float 64 bits type !

!MDDSFloat64Type class methodsFor: 'pseudo-dsl' stamp: 'SantiagoBragagnolo 9/16/2014 20:41'!
alterName
	^ #Float64! !

!MDDSFloat64Type class methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/16/2014 20:41'!
dataTypeSize
	^ 8! !

!MDDSFloat64Type methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/15/2012 17:11'!
decode: aFLDecoder 
	^ aFLDecoder nextEncodedFloat64.! !

!MDDSFloat64Type methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 4/5/2013 17:01'!
isAPossibleValue: aFloat 
	
	
	^(aFloat isKindOf: Float)
	
	
	" and: [
		aFloat = 0 or: [
			| encoder decoder stream |
			stream := WriteStream on: (ByteArray new: 4).
			encoder := PhaROSEncoder on:stream .
			encoder encodefloat32: aFloat.
			encoder flush.
			stream := ReadStream on: stream contents.
			decoder := PhaROSDecoder on: stream.
			aFloat closeTo: decoder nextEncodedFloat64
		].
	]"! !

!MDDSFloat64Type methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/26/2014 08:22'!
newInstance 
	^ 0.0.! !

!MDDSFloat64Type methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/15/2012 17:12'!
setEncodeDecodeSelectors 
	decodeSelector := #nextEncodedFloat64.
	encodeSelector := #encodefloat64:.
	 ! !

!MDDSFloat64Type methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/26/2014 08:23'!
typeName 
	^ self error: 'float64'.! !

MDDSBaseTypeMarshaller subclass: #MDDSHeaderType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-TypesMarshalling'!

!MDDSHeaderType commentStamp: 'SantiagoBragagnolo 10/1/2014 16:24' prior: 0!
A MDDSHeaderType is an special kind of type that is strictly developed for the handshake tear of the any protocol.!

!MDDSHeaderType class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/26/2014 08:25'!
alterName
	^ #HeaderAttribute! !

!MDDSHeaderType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/1/2014 14:20'!
calculateAttributeLength: anAttribute
	^ 4 + anAttribute name asByteArray size + anAttribute value asByteArray size + 1.
	
" Size of the encoded size of the value
the size of the name
the size of the value
the size of the = character"! !

!MDDSHeaderType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/1/2014 16:14'!
dataTypeSizeFor: aValue
	^ aValue attributes inject: 0 into: [ : acc :each | acc + (self calculateAttributeLength: each) ] .! !

!MDDSHeaderType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/1/2014 14:15'!
defaultValueString 
	^ ' MDDSHandshakeHeader new'.
	! !

!MDDSHeaderType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/26/2014 08:24'!
isAPossibleValue: aValue 
	self shouldBeImplemented 
	
	! !

!MDDSHeaderType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/1/2014 14:15'!
newInstance 
	^ MDDSHandshakeHeader new.! !

!MDDSHeaderType methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/1/2014 16:20'!
relatedClass
	^ MDDSHandshakeHeader ! !

!MDDSHeaderType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/1/2014 14:09'!
setEncodeDecodeSelectors 
	decodeSelector := #nextEncodedHeader.
	encodeSelector := #encodeHeader:.
	 ! !

!MDDSHeaderType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/1/2014 14:23'!
sizeFor: aDecoder 
	^aDecoder nextEncodedUint32.! !

!MDDSHeaderType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/26/2014 08:23'!
typeName 
	^ self error: 'do not apply'.! !

MDDSBaseTypeMarshaller subclass: #MDDSInt16Type
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-TypesMarshalling'!

!MDDSInt16Type commentStamp: '<historical>' prior: 0!
A PhaROSInt16Type is a 16 bits represetnation of int !

!MDDSInt16Type class methodsFor: 'pseudo-dsl' stamp: 'SantiagoBragagnolo 9/16/2014 20:42'!
alterName
	^ #Int16! !

!MDDSInt16Type class methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/16/2014 20:42'!
dataTypeSize
	^ 2! !

!MDDSInt16Type methodsFor: 'testing' stamp: 'SantiagoBragagnolo 10/9/2012 17:46'!
isAPossibleValue: aSmallInteger 
	^(aSmallInteger isKindOf: SmallInteger) and: [
		aSmallInteger > -32769 and: [  aSmallInteger < 32768 ]
	].! !

!MDDSInt16Type methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/3/2012 14:25'!
newInstance 
	^ 0.! !

!MDDSInt16Type methodsFor: 'initializing' stamp: 'SantiagoBragagnolo 10/9/2012 17:55'!
setEncodeDecodeSelectors
	decodeSelector := #nextEncodedInt16.
	encodeSelector := #encodeInt16:.! !

!MDDSInt16Type methodsFor: 'initializing' stamp: 'SantiagoBragagnolo 5/28/2013 13:43'!
typeName 
	^ 'int16'! !

MDDSBaseTypeMarshaller subclass: #MDDSInt32Type
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-TypesMarshalling'!

!MDDSInt32Type commentStamp: '<historical>' prior: 0!
A PhaROSInt32Type  is a 32 bits represetnation of int !

!MDDSInt32Type class methodsFor: 'pseudo-dsl' stamp: 'SantiagoBragagnolo 9/16/2014 20:42'!
alterName
	^ #Int32! !

!MDDSInt32Type class methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/16/2014 20:42'!
dataTypeSize
	^ 4! !

!MDDSInt32Type methodsFor: 'testing' stamp: 'SantiagoBragagnolo 10/10/2012 10:58'!
isAPossibleValue: aNumber
	^(aNumber isKindOf: Number )and: [
		aNumber >	-2147483649 and: [ aNumber  < 2147483648 ]
	]
! !

!MDDSInt32Type methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/3/2012 14:25'!
newInstance 
	^ 0.! !

!MDDSInt32Type methodsFor: 'initializing' stamp: 'SantiagoBragagnolo 10/10/2012 10:55'!
setEncodeDecodeSelectors
	decodeSelector := #nextEncodedInt32.
	encodeSelector := #encodeInt32:.! !

!MDDSInt32Type methodsFor: 'initializing' stamp: 'SantiagoBragagnolo 5/28/2013 13:43'!
typeName 
	^ 'int32'! !

MDDSBaseTypeMarshaller subclass: #MDDSInt64Type
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-TypesMarshalling'!

!MDDSInt64Type commentStamp: '<historical>' prior: 0!
A PhaROSInt64Type  is a 64 bits represetnation of int !

!MDDSInt64Type class methodsFor: 'pseudo-dsl' stamp: 'SantiagoBragagnolo 9/16/2014 20:42'!
alterName
	^ #Int64! !

!MDDSInt64Type class methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/16/2014 20:42'!
dataTypeSize
	^ 8! !

!MDDSInt64Type methodsFor: 'testing' stamp: 'SantiagoBragagnolo 10/10/2012 11:08'!
isAPossibleValue: aNumber
	^( aNumber isKindOf: Number )and: [
		aNumber > -9223372036854775809  and: [ aNumber <  9223372036854775808].
	]
	! !

!MDDSInt64Type methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/3/2012 14:24'!
newInstance 
	^ 0.! !

!MDDSInt64Type methodsFor: 'initialize' stamp: 'SantiagoBragagnolo 10/10/2012 11:03'!
setEncodeDecodeSelectors
	decodeSelector := #nextEncodedInt64.
	encodeSelector := #encodeInt64:.
	
! !

!MDDSInt64Type methodsFor: 'initialize' stamp: 'SantiagoBragagnolo 5/28/2013 13:43'!
typeName 
	^ 'int64'! !

MDDSBaseTypeMarshaller subclass: #MDDSInt8Type
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-TypesMarshalling'!

!MDDSInt8Type commentStamp: '<historical>' prior: 0!
A PhaROSInt8Type i is a 8 bits represetnation of int. Also used as byte or char.!

!MDDSInt8Type class methodsFor: 'pseudo-dsl' stamp: 'SantiagoBragagnolo 9/16/2014 20:42'!
alterName
	^ #Int8! !

!MDDSInt8Type class methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/16/2014 20:42'!
dataTypeSize
	^1.! !

!MDDSInt8Type methodsFor: 'serialize' stamp: 'SantiagoBragagnolo 10/10/2012 10:35'!
decode: aFLDecoder 

	^aFLDecoder nextEncodedInt8.! !

!MDDSInt8Type methodsFor: 'testing' stamp: 'SantiagoBragagnolo 9/30/2012 14:51'!
isAPossibleValue: aSmallInteger 
	^(aSmallInteger isKindOf: Number) and: [ aSmallInteger > -129 and: [ aSmallInteger < 128 ] ].! !

!MDDSInt8Type methodsFor: 'serialize' stamp: 'SantiagoBragagnolo 10/3/2012 14:24'!
newInstance 
	^ 0.! !

!MDDSInt8Type methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/9/2012 12:27'!
setEncodeDecodeSelectors 
	decodeSelector := #nextEncodedInt8.
	encodeSelector := #encodeInt8:.
	 
	! !

!MDDSInt8Type methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/28/2013 13:43'!
typeName 
	^ 'int8'! !

MDDSBaseTypeMarshaller subclass: #MDDSStringType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-TypesMarshalling'!

!MDDSStringType commentStamp: '<historical>' prior: 0!
A PhaROSStringType is a variable length string type!

!MDDSStringType class methodsFor: 'pseudo-dsl' stamp: 'SantiagoBragagnolo 9/16/2014 20:42'!
registerAlterName
	" Name collision. DSL constructor name is at String class as extention method "! !

!MDDSStringType methodsFor: 'testing' stamp: 'SantiagoBragagnolo 2/21/2013 12:26'!
" self new constantValue: ($' asString) "
constantValue: aValue 
	| realValue | 

	realValue := aValue copyReplaceAll: $' asString with:($' asString, $' asString).
	
	^  $' asString , realValue, $' asString.
	! !

!MDDSStringType methodsFor: 'initialize-release' stamp: 'SantiagoBragagnolo 2/22/2013 16:23'!
dataTypeSize
	^ 2048.! !

!MDDSStringType methodsFor: 'initialize-release' stamp: 'SantiagoBragagnolo 11/6/2012 16:01'!
dataTypeSizeFor: aValue
	(self isAPossibleValue: aValue ) ifFalse: [
		PhaROSUnexpextedValue signal: 'Unexpected value'.
	].
	^ aValue size + 4.! !

!MDDSStringType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/15/2012 15:37'!
defaultValueString 
	^ $' asString, $' asString. ! !

!MDDSStringType methodsFor: 'initialize-release' stamp: 'SantiagoBragagnolo 10/9/2012 17:44'!
isAPossibleSize: aSize
	^ aSize > 0.! !

!MDDSStringType methodsFor: 'testing' stamp: 'SantiagoBragagnolo 10/9/2012 13:50'!
isAPossibleValue: aByteString 
	^ aByteString isKindOf: ByteString.! !

!MDDSStringType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/3/2012 15:22'!
newInstance 
	^ ''. ! !

!MDDSStringType methodsFor: 'initialize-release' stamp: 'SantiagoBragagnolo 10/9/2012 13:43'!
setEncodeDecodeSelectors
	encodeSelector := #encodeString:.
	decodeSelector := #nextEncodedString.! !

!MDDSStringType methodsFor: 'initialize-release' stamp: 'SantiagoBragagnolo 5/28/2013 13:44'!
typeName 
	^ 'string'! !

MDDSBaseTypeMarshaller subclass: #MDDSTimeType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-TypesMarshalling'!

!MDDSTimeType commentStamp: '<historical>' prior: 0!
A PhaROSTimeType is a time stamp type.!

!MDDSTimeType class methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/16/2014 20:43'!
dataTypeSize
	^ 8! !

!MDDSTimeType class methodsFor: 'pseudo-dsl' stamp: 'SantiagoBragagnolo 9/16/2014 20:43'!
registerAlterName
	" Name collision. DSL constructor name is at Time class as extention method "! !

!MDDSTimeType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/19/2014 19:50'!
defaultValueString
	^ ' MDDSTimestamp now'. ! !

!MDDSTimeType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/15/2014 20:12'!
isAPossibleValue: aTime 
	^ (aTime isKindOf: MDDSTimestamp) and: [
		aTime seconds  < 4294967296 and: [
			aTime nanoSeconds  < 4294967296 
		]
	].! !

!MDDSTimeType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/10/2012 11:43'!
newInstance 
	^ Time new. ! !

!MDDSTimeType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/10/2012 11:37'!
setEncodeDecodeSelectors
	encodeSelector := #encodeTime:.
	decodeSelector := #nextEncodedTime.! !

!MDDSTimeType methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/28/2013 13:44'!
typeName 
	^ 'time'! !

MDDSBaseTypeMarshaller subclass: #MDDSUInt16Type
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-TypesMarshalling'!

!MDDSUInt16Type commentStamp: '<historical>' prior: 0!
A PhaROSUInt16Type  is a 16 bits represetnation of unsigned int !

!MDDSUInt16Type class methodsFor: 'pseudo-dsl' stamp: 'SantiagoBragagnolo 9/16/2014 20:43'!
alterName
	^ #UInt16! !

!MDDSUInt16Type class methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/16/2014 20:43'!
dataTypeSize
	^ 2! !

!MDDSUInt16Type methodsFor: 'serialize' stamp: 'SantiagoBragagnolo 1/22/2014 12:19'!
decode: aFLDecoder 
	[
		^ aFLDecoder nextEncodedUint16.
	] on: Error do: [
		self signal: 'cannot load value'.
	].! !

!MDDSUInt16Type methodsFor: 'testing' stamp: 'SantiagoBragagnolo 9/28/2012 15:50'!
isAPossibleValue: aNumber
	^(aNumber isKindOf: Number) and:[ aNumber >= 0 and: [ aNumber < 65536]].
	! !

!MDDSUInt16Type methodsFor: 'serialize' stamp: 'SantiagoBragagnolo 10/3/2012 14:28'!
newInstance 
	^ 0.! !

!MDDSUInt16Type methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/9/2012 16:43'!
setEncodeDecodeSelectors 
	decodeSelector := #nextEncodedUInt16.
	encodeSelector := #encodeUint16:.
	 
	
	! !

!MDDSUInt16Type methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/28/2013 13:44'!
typeName 
	^ 'uint16'! !

MDDSBaseTypeMarshaller subclass: #MDDSUInt32Type
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-TypesMarshalling'!

!MDDSUInt32Type commentStamp: '<historical>' prior: 0!
A PhaROSUInt32Type   is a 32 bits represetnation of unsigned int !

!MDDSUInt32Type class methodsFor: 'pseudo-dsl' stamp: 'SantiagoBragagnolo 9/16/2014 20:43'!
alterName
	^ #UInt32! !

!MDDSUInt32Type class methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/16/2014 20:43'!
dataTypeSize
	^ 4! !

!MDDSUInt32Type methodsFor: 'serialize' stamp: 'SantiagoBragagnolo 10/2/2012 17:19'!
decode: aFLDecoder 
	^ aFLDecoder nextEncodedUint32 ! !

!MDDSUInt32Type methodsFor: 'testing' stamp: 'SantiagoBragagnolo 9/28/2012 16:58'!
isAPossibleValue: aValue 
	^ (aValue isKindOf: Number )and:[ aValue >= 0  and:[ aValue <  4294967296]] .! !

!MDDSUInt32Type methodsFor: 'serialize' stamp: 'SantiagoBragagnolo 10/3/2012 14:28'!
newInstance 
	^ 0.! !

!MDDSUInt32Type methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/9/2012 12:28'!
setEncodeDecodeSelectors 
	decodeSelector := #nextEncodedUint32.
	encodeSelector := #encodeUint32:.
	
! !

!MDDSUInt32Type methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/28/2013 13:44'!
typeName 
	^ 'int32'! !

MDDSBaseTypeMarshaller subclass: #MDDSUInt64Type
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-TypesMarshalling'!

!MDDSUInt64Type commentStamp: '<historical>' prior: 0!
A PhaROSUInt64Type  is a 64 bits represetnation of unsigned int !

!MDDSUInt64Type class methodsFor: 'pseudo-dsl' stamp: 'SantiagoBragagnolo 9/16/2014 20:43'!
alterName
	^ #UInt64! !

!MDDSUInt64Type class methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/16/2014 20:43'!
dataTypeSize
	^ 8! !

!MDDSUInt64Type methodsFor: 'serialize' stamp: 'SantiagoBragagnolo 10/9/2012 11:42'!
decode: aFLDecoder 
	^ aFLDecoder nextEncodedUint64.! !

!MDDSUInt64Type methodsFor: 'testing' stamp: 'SantiagoBragagnolo 9/28/2012 17:11'!
isAPossibleValue: aValue 
	^ (aValue isKindOf: Number )and:[ aValue >= 0  and:[ aValue <  18446744073709551616]] .! !

!MDDSUInt64Type methodsFor: 'serialize' stamp: 'SantiagoBragagnolo 10/3/2012 14:28'!
newInstance 
	^ 0.! !

!MDDSUInt64Type methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/9/2012 12:32'!
setEncodeDecodeSelectors 
	decodeSelector := #nextEncodedUint64.
	encodeSelector := #encodeUint64:.
	
! !

!MDDSUInt64Type methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/28/2013 13:44'!
typeName 
	^ 'int64'! !

MDDSBaseTypeMarshaller subclass: #MDDSUInt8Type
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-TypesMarshalling'!

!MDDSUInt8Type commentStamp: '<historical>' prior: 0!
A PhaROSUInt8Type   is a 8 bits represetnation of unsigned int !

!MDDSUInt8Type class methodsFor: 'pseudo-dsl' stamp: 'SantiagoBragagnolo 9/16/2014 20:43'!
alterName
	^ #UInt8! !

!MDDSUInt8Type class methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/16/2014 20:43'!
dataTypeSize 
	^ 1! !

!MDDSUInt8Type class methodsFor: 'serialize' stamp: 'SantiagoBragagnolo 9/16/2014 20:43'!
unserialize: aByteArray
	self assert: aByteArray size = 1.
	^ self value: (aByteArray at: 1); yourself.! !

!MDDSUInt8Type methodsFor: 'serialize' stamp: 'SantiagoBragagnolo 10/2/2012 17:17'!
decode: aFLDecoder
	^ aFLDecoder nextEncodedByte.! !

!MDDSUInt8Type methodsFor: 'testing' stamp: 'SantiagoBragagnolo 9/28/2012 14:18'!
isAPossibleValue: aValue
	^ (aValue isKindOf: Number) and: [
		aValue >= 0 and:[ aValue < 256 ]
	].
	! !

!MDDSUInt8Type methodsFor: 'serialize' stamp: 'SantiagoBragagnolo 10/3/2012 14:28'!
newInstance 
	^ 0.! !

!MDDSUInt8Type methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/9/2012 12:33'!
setEncodeDecodeSelectors 
	decodeSelector := #nextEncodedUint8.
	encodeSelector := #encodeUint8:.
	! !

!MDDSUInt8Type methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 5/28/2013 13:44'!
typeName 
	^ 'int8'! !

Object subclass: #MDDSBasicTypeDefinition
	instanceVariableNames: 'typeSerializer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-TypesDefinition'!

!MDDSBasicTypeDefinition commentStamp: '<historical>' prior: 0!
This builder is a polimorfic object that allow us to have a builder that do not build, for the basic types, as Uint, etc.!

!MDDSBasicTypeDefinition class methodsFor: 'instance creation' stamp: 'SantiagoBragagnolo 9/19/2014 19:47'!
for: aType
	^ self new typeSerializer: aType; yourself.! !

!MDDSBasicTypeDefinition methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 11/26/2014 20:57'!
beRegisteredBy: aTypeLoader
	^ self! !

!MDDSBasicTypeDefinition methodsFor: 'building' stamp: 'SantiagoBragagnolo 10/3/2014 15:46'!
buildTypeMarshaller
	^ typeSerializer.! !

!MDDSBasicTypeDefinition methodsFor: 'building' stamp: 'SantiagoBragagnolo 9/19/2014 19:47'!
typeBuilder
	^ self.! !

!MDDSBasicTypeDefinition methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 2/13/2015 22:05'!
typeName
	^ typeSerializer typeName.! !

!MDDSBasicTypeDefinition methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/19/2014 20:26'!
typeSerializer
	^ typeSerializer! !

!MDDSBasicTypeDefinition methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/19/2014 19:47'!
typeSerializer: aTypeSerializer 
	typeSerializer := aTypeSerializer.! !

MDDSBasicTypeDefinition subclass: #MDDSCollectionTypeDefinition
	instanceVariableNames: 'innerTypeDefinition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-TypesDefinition'!

!MDDSCollectionTypeDefinition class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/26/2014 11:59'!
for: aType
	self error: 'Collection based type definition needs a collection type and an inner type: Use for:storing: instead'! !

!MDDSCollectionTypeDefinition class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/26/2014 12:00'!
for: aCollectionType storing: anInnerTypeDefinition
	^ (super for: aCollectionType) innerTypeDefinition: anInnerTypeDefinition; yourself! !

!MDDSCollectionTypeDefinition methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/26/2014 20:57'!
beRegisteredBy: aTypeLoader
	innerTypeDefinition beRegisteredBy: aTypeLoader.
	^ self.! !

!MDDSCollectionTypeDefinition methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/26/2014 12:10'!
buildTypeMarshaller
	^ typeSerializer relatedType: (innerTypeDefinition typeBuilder buildTypeMarshaller)! !

!MDDSCollectionTypeDefinition methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/26/2014 12:00'!
innerTypeDefinition: anInnerTypeDefinition
	innerTypeDefinition := anInnerTypeDefinition! !

Object subclass: #MDDSConnection
	instanceVariableNames: 'protocol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSConnection commentStamp: 'SantiagoBragagnolo 11/17/2014 16:18' prior: 0!
A MDDSConnection is the reification of a connection in between publisher and subscriber!

!MDDSConnection methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/27/2014 12:49'!
destroy! !

!MDDSConnection methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/7/2014 20:37'!
id
 	^ self hash asString! !

!MDDSConnection methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/7/2014 20:35'!
isConnected
	^ socket isConnected! !

!MDDSConnection methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/7/2014 20:33'!
isReader
	^ false! !

!MDDSConnection methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/27/2014 22:19'!
noteIsRegistered! !

!MDDSConnection methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/7/2014 20:36'!
protocol
	^ protocol! !

!MDDSConnection methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/7/2014 20:36'!
protocol: anObject
	protocol := anObject! !

MDDSConnection subclass: #MDDSReadingConnection
	instanceVariableNames: 'typeMarshaller messageDispatcher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSReadingConnection methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/24/2014 16:07'!
isReader
	^ true! !

!MDDSReadingConnection methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/24/2014 16:07'!
marshaller: aTypeMarshaller
	typeMarshaller := aTypeMarshaller! !

!MDDSReadingConnection methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/24/2014 16:07'!
messageDispatcher: aMessageDispatcher
	messageDispatcher := aMessageDispatcher.! !

MDDSReadingConnection subclass: #MDDSReadingNetworkConnection
	instanceVariableNames: 'keepRunning process stream urlrpc socket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSReadingNetworkConnection commentStamp: 'SantiagoBragagnolo 10/6/2014 18:33' prior: 0!
Reading connection is a reification of the socket, with protocol and marshalling in terms of consuming !

!MDDSReadingNetworkConnection class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/2/2014 23:44'!
protocol: aProtocol socket: aSocket stream: aStream
	^ self new protocol: aProtocol ; socket: aSocket ; stream: aStream;  yourself! !

!MDDSReadingNetworkConnection methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 11/28/2014 14:46'!
destroy
	self stop.
	messageDispatcher := nil.
	socket close.
	socket := nil.
	stream close.
	stream := nil.
	protocol := nil.
	process := nil. ! !

!MDDSReadingNetworkConnection methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/2/2014 15:54'!
initialize
	keepRunning := false.! !

!MDDSReadingNetworkConnection methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/27/2014 22:19'!
noteIsRegistered
	super noteIsRegistered.
	self start.! !

!MDDSReadingNetworkConnection methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/27/2014 12:48'!
socket
	^ socket! !

!MDDSReadingNetworkConnection methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/27/2014 12:48'!
socket: anObject
	socket := anObject! !

!MDDSReadingNetworkConnection methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 11/23/2014 23:45'!
start
	keepRunning
		ifFalse: [ 
			keepRunning := true.
			process := [ 
			| value |
			[ keepRunning ]
				whileTrue: [ 
					[ 
					value := protocol loadStream: stream with: typeMarshaller.
					messageDispatcher dispatch: value ]
						on: Error
						do: [ :err | 
							messageDispatcher noteError: err.
							keepRunning := socket isConnected ] ].
			messageDispatcher noteStop: self.
			self destroy ] shootIt asStickyReference ]
		ifTrue: [ self error: 'The related process is already running!!' ]! !

!MDDSReadingNetworkConnection methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/20/2014 22:10'!
stop
	keepRunning
		ifTrue: [ 
			keepRunning := false.
			process := nil ]
		ifFalse: [ self error: 'The related process is notrunning!!' ]! !

!MDDSReadingNetworkConnection methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/2/2014 23:44'!
stream: aStream
	stream := aStream.! !

!MDDSReadingNetworkConnection methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/17/2014 14:56'!
urlrpc
	^ urlrpc! !

!MDDSReadingNetworkConnection methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/17/2014 14:56'!
urlrpc: anUrl
	urlrpc := anUrl.! !

MDDSReadingConnection subclass: #MDDSReadingReferenceConnection
	instanceVariableNames: 'participant'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSReadingReferenceConnection commentStamp: 'SantiagoBragagnolo 11/17/2014 16:19' prior: 0!
A MDDSReadingReferenceConnection

is the reification of the reading connection but based on a reference. Is for local participants!

!MDDSReadingReferenceConnection class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/27/2014 13:20'!
dispatchingTo: aMessageDispatcher
	^ self new messageDispatcher: aMessageDispatcher; yourself.! !

!MDDSReadingReferenceConnection methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/27/2014 13:15'!
dispatch: aMessage
	messageDispatcher dispatch: aMessage.! !

!MDDSReadingReferenceConnection methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/27/2014 22:50'!
participant
	^ participant! !

!MDDSReadingReferenceConnection methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/27/2014 22:49'!
participant: aParticipant
	participant := aParticipant! !

MDDSConnection subclass: #MDDSWritingConnection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSWritingConnection methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/24/2014 16:08'!
isDead
	^ self subclassResponsibility ! !

!MDDSWritingConnection methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/24/2014 16:09'!
write: aDataValue with: aMarshaller
	^ self subclassResponsibility ! !

MDDSWritingConnection subclass: #MDDSWritingNetworkConnection
	instanceVariableNames: 'socket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSWritingNetworkConnection commentStamp: 'SantiagoBragagnolo 10/17/2014 14:57' prior: 0!
a writing connection puts together socket protocol and eventually, marshaller (since the marshaller is the same for each topic actor, is not accessed here, but received just in time) 

!

!MDDSWritingNetworkConnection class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/6/2014 17:31'!
with: aProtocol for: aSocket
	^ self new protocol: aProtocol ; socket: aSocket; yourself! !

!MDDSWritingNetworkConnection methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/27/2014 12:49'!
destroy
	socket close.! !

!MDDSWritingNetworkConnection methodsFor: 'testing' stamp: 'SantiagoBragagnolo 10/27/2014 12:49'!
isDead
	^ socket isNil or: [ socket isConnected not ]! !

!MDDSWritingNetworkConnection methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/27/2014 12:48'!
socket
	^ socket! !

!MDDSWritingNetworkConnection methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/27/2014 12:48'!
socket: anObject
	socket := anObject! !

!MDDSWritingNetworkConnection methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:11'!
write: aDataValue with: aMarshaller
	" there are several scenarios where the data is not much per cycle and is sent several times per second. For this cases (sensors) having a batched writing may  be a great enhancement "

	self flag: #performance.
	socket sendData: (protocol dump: aDataValue with: aMarshaller)! !

MDDSWritingConnection subclass: #MDDSWritingReferenceConnection
	instanceVariableNames: 'link participant'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSWritingReferenceConnection commentStamp: 'SantiagoBragagnolo 11/17/2014 16:19' prior: 0!
A MDDSWritingReferenceConnection is 
is the reification of the writing connection but based on a reference. Is for local participants!

!MDDSWritingReferenceConnection class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/27/2014 13:17'!
linkedTo: aReadingConnection
	^ self new link:  aReadingConnection; yourself! !

!MDDSWritingReferenceConnection class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/24/2014 17:25'!
subscribing: aSubscription
	^ self new subscription: aSubscription; yourself! !

!MDDSWritingReferenceConnection methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/27/2014 22:48'!
isDead
	^ link isNil! !

!MDDSWritingReferenceConnection methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/27/2014 13:17'!
link: aReadingConnection
	link := aReadingConnection.! !

!MDDSWritingReferenceConnection methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/27/2014 22:57'!
participant
	^ participant! !

!MDDSWritingReferenceConnection methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/27/2014 22:57'!
participant: aParticipant
	participant := aParticipant! !

!MDDSWritingReferenceConnection methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/27/2014 13:18'!
write: aDataValue with: aMarshaller
	link dispatch: aDataValue.! !

Object subclass: #MDDSConnectionDescription
	instanceVariableNames: 'participant topicInteractor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSConnectionDescription commentStamp: 'SantiagoBragagnolo 10/6/2014 14:28' prior: 0!
part of the dds architecutre includes for connection details, and, as well, support to several kind of IP based protocols. !

!MDDSConnectionDescription methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/6/2014 15:02'!
itIsSupportedBy: aProtocol
	self subclassResponsibility ! !

!MDDSConnectionDescription methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/6/2014 15:01'!
latching
	^ '0'.! !

!MDDSConnectionDescription methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/6/2014 15:01'!
participant
	^ participant.! !

!MDDSConnectionDescription methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/6/2014 15:01'!
participant: aParticipantMirror
	 participant := aParticipantMirror.! !

!MDDSConnectionDescription methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/6/2014 15:06'!
topic
	^ topicInteractor topic! !

!MDDSConnectionDescription methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/6/2014 15:05'!
topicInteractor
	^ topicInteractor! !

!MDDSConnectionDescription methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/6/2014 15:05'!
topicInteractor: anObject
	topicInteractor := anObject! !

!MDDSConnectionDescription methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/14/2014 11:59'!
validateAndProcessHeader: aHeader
	^ (self topic name = aHeader topic and: [ self topic type verify: aHeader type md5: aHeader md5sum ])
		ifTrue: [ 
			self topic noticeConnectionWith: aHeader.
			true ]
		ifFalse: [ false ]! !

MDDSConnectionDescription subclass: #MDDSConnectionOffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSConnectionOffer commentStamp: 'SantiagoBragagnolo 10/6/2014 14:28' prior: 0!
part of the dds architecutre includes a offers for connection, and, as well, support to several kind of IP based protocols!

!MDDSConnectionOffer class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/6/2014 15:09'!
publisher: aPublisher participant: aParticipantMirror 
	^ self new topicInteractor: aPublisher; participant: aParticipantMirror ;yourself ! !

!MDDSConnectionOffer methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:11'!
itIsSupportedBy: aProtocol
	^ participant protocols anySatisfy: [ :p | p name = aProtocol name ]! !

MDDSConnectionDescription subclass: #MDDSConnectionPetition
	instanceVariableNames: 'protocolName ip port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSConnectionPetition commentStamp: 'SantiagoBragagnolo 9/25/2014 20:27' prior: 0!
part of the dds architecutre includes a petition for connection, and, as well, support to several kind of IP based protocols!

!MDDSConnectionPetition class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/6/2014 15:04'!
protocolName: aName ip: anIp port: aPort subscriber: aSubscriber participant: aParticipantMirror 
	^ self new protocolName: aName; ip: anIp; port: aPort; topicInteractor: aSubscriber; participant: aParticipantMirror ;yourself ! !

!MDDSConnectionPetition methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/25/2014 20:29'!
ip
	^ ip! !

!MDDSConnectionPetition methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/25/2014 20:25'!
ip: anIPOrHostName
	ip := anIPOrHostName ! !

!MDDSConnectionPetition methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/25/2014 20:29'!
itIsSupportedBy: aProtocol
	^ aProtocol name = protocolName! !

!MDDSConnectionPetition methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/25/2014 20:29'!
port
	^ port! !

!MDDSConnectionPetition methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/25/2014 20:25'!
port: aPort
	port := aPort.! !

!MDDSConnectionPetition methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/25/2014 20:25'!
protocolName: aName
	protocolName := aName.
	! !

Object subclass: #MDDSDecoder
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Encoding'!

!MDDSDecoder commentStamp: '<historical>' prior: 0!
A PhaROSDecoder is stream encoder. It reads from a given stream. It expose several methods per type. !

!MDDSDecoder class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/30/2014 14:04'!
on: aReadStream
	^self new stream: aReadStream; yourself.! !

!MDDSDecoder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 2/27/2013 14:54'!
hasLeft: anAmountOfBytes
	 self flag: #comment.
	
	^ true.
	
	"
		since SocketStream doesnot understand position, this maybe has not sense. 
		^stream position + anAmountOfBytes <= stream size.
	"! !

!MDDSDecoder methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/9/2012 11:53'!
minimumPrecision
	^ 0.002! !

!MDDSDecoder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:03'!
nextEncodedByte
	self verifyDataAvailability.
	^ stream next! !

!MDDSDecoder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:03'!
nextEncodedDuration
	| duration |
	self verifyDataAvailability: 4 * 2.
	duration := Duration new.
	duration seconds: self nextEncodedUint32 nanoSeconds: self nextEncodedUint32.
	^ duration! !

!MDDSDecoder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:03'!
nextEncodedFloat32
	self verifyDataAvailability: 4.
	^ (Float fromIEEE32BitByteArray: (stream next: 4)) roundUpTo: self minimumPrecision! !

!MDDSDecoder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:03'!
nextEncodedFloat64
	self verifyDataAvailability: 8.
	^ (stream next: 8) doubleAt: 1 bigEndian: false! !

!MDDSDecoder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:03'!
nextEncodedInt16
	| n firstDigit barray |
	self verifyDataAvailability: 2.
	barray := ReadStream on: (stream next: 2) reversed.
	n := firstDigit := barray next.
	n := (n bitShift: 8) + barray next.
	firstDigit >= 128
		ifTrue: [ n := -16r10000 + n ].	"decode negative 16-bit integer"
	^ n! !

!MDDSDecoder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:04'!
nextEncodedInt32
	| n firstDigit barray |
	self verifyDataAvailability: 4.
	barray := ReadStream on: (stream next: 4) reversed.
	n := firstDigit := barray next.
	n := (n bitShift: 8) + barray next.
	n := (n bitShift: 8) + barray next.
	n := (n bitShift: 8) + barray next.
	firstDigit >= 128
		ifTrue: [ n := -16r100000000 + n ].	"decode negative 32-bit integer"
	^ n! !

!MDDSDecoder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:04'!
nextEncodedInt64
	| n firstDigit barray |
	self verifyDataAvailability: 8.
	barray := stream next: 8.
	barray size = 8
		ifFalse: [ Error signal: ' there are less than 8 bytes in the stream ' ].
	barray := ReadStream on: barray reversed.
	n := firstDigit := barray next.
	n := (n bitShift: 8) + barray next.
	n := (n bitShift: 8) + barray next.
	n := (n bitShift: 8) + barray next.
	n := (n bitShift: 8) + barray next.
	n := (n bitShift: 8) + barray next.
	n := (n bitShift: 8) + barray next.
	n := (n bitShift: 8) + barray next.
	firstDigit >= 128
		ifTrue: [ n := -16r10000000000000000 + n ].	"decode negative 64-bit integer"
	^ n! !

!MDDSDecoder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:04'!
nextEncodedInt8
	| digit |
	self verifyDataAvailability.
	digit := stream next.
	^ digit < 128
		ifTrue: [ digit ]
		ifFalse: [ -16r100 + digit ]! !

!MDDSDecoder methodsFor: 'serialize' stamp: 'SantiagoBragagnolo 10/20/2014 22:04'!
nextEncodedString
	| length aByteArray |
	[ length := self nextEncodedUint32 ]
		on: Error
		do: [ Error signal: 'Unable to load string size' ].
	self verifyDataAvailability: length.
	aByteArray := ByteArray new: length.
	stream nextInto: aByteArray.
	^ aByteArray asString! !

!MDDSDecoder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:04'!
nextEncodedTime
	self verifyDataAvailability: 4 * 2.
	^ MDDSTimestamp fromUnixTime: self nextEncodedUint32 nanoSeconds: self nextEncodedUint32! !

!MDDSDecoder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:04'!
nextEncodedUint16
	| n barray |
	self verifyDataAvailability: 2.
	barray := ReadStream on: (stream next: 2) reversed.
	n := barray next.
	n := (n bitShift: 8) + barray next.
	^ n! !

!MDDSDecoder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:04'!
nextEncodedUint32
	| n  firstDigit src barray |
	self verifyDataAvailability: 4.
	src := stream next: 4.
	barray := ReadStream on: src reversed.
	[ 
	n := firstDigit := barray next.
	n := (n bitShift: 8) + barray next.
	n := (n bitShift: 8) + barray next.
	n := (n bitShift: 8) + barray next ]
		on: Error
		do: [ MDDSError signal: 'Unable to load 32bits UInt' ].
	^ n! !

!MDDSDecoder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:04'!
nextEncodedUint64
	| n firstDigit barray |
	self verifyDataAvailability: 8.
	barray := ReadStream on: (stream next: 8) reversed.
	n := firstDigit := barray next.
	n := (n bitShift: 8) + barray next.
	n := (n bitShift: 8) + barray next.
	n := (n bitShift: 8) + barray next.
	n := (n bitShift: 8) + barray next.
	n := (n bitShift: 8) + barray next.
	n := (n bitShift: 8) + barray next.
	n := (n bitShift: 8) + barray next.
	^ n! !

!MDDSDecoder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:05'!
nextEncodedUint8
	self verifyDataAvailability.
	^ stream next! !

!MDDSDecoder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/1/2014 12:16'!
resetBuffers
	stream resetBuffers.! !

!MDDSDecoder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/9/2012 09:59'!
stream: aStream
	stream := aStream.! !

!MDDSDecoder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 1/30/2013 16:20'!
verifyDataAvailability
	^ self verifyDataAvailability: 1.! !

!MDDSDecoder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:05'!
verifyDataAvailability: anAmount
	(self hasLeft: anAmount)
		ifFalse: [ self error: 'There are no more data' ]! !

MDDSDecoder subclass: #MDDSHeaderDecoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Encoding'!

!MDDSHeaderDecoder commentStamp: 'SantiagoBragagnolo 10/1/2014 16:23' prior: 0!
A MDDSHeaderDecoder is specific decoder that is used for header logic. It is not defined in the main decoder because is kind of addon, since the type system is a bit different. Then, in order to keep the rest clear all this logic is encapsulated!

!MDDSHeaderDecoder class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/26/2014 08:38'!
fieldNameSeparator
	^61 "$=  asInteger"! !

!MDDSHeaderDecoder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:05'!
nextEncodedAttribute
	| fieldsize buffer name rawValue |
	fieldsize := self nextEncodedUint32.
	buffer := ReadStream on: (stream next: fieldsize).
	name := buffer upTo: self class fieldNameSeparator.
	rawValue := buffer upToEnd.
	^ MDDSHeaderAtribute name: name asString value: rawValue asString! !

!MDDSHeaderDecoder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:05'!
nextEncodedHeader
	| headerSize backupStream header |
	headerSize := self nextEncodedUint32.
	backupStream := stream.
	header := MDDSHandshakeHeader new.
	[ 
	stream := ReadStream on: (backupStream next: headerSize).
	[ stream atEnd ] whileFalse: [ header attributes add: self nextEncodedAttribute ] ]
		ensure: [ stream := backupStream ].
	^ header! !

Object subclass: #MDDSEncoder
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Encoding'!

!MDDSEncoder commentStamp: '<historical>' prior: 0!
A PhaROSEncoder is stream encoder. It writes in a given stream. It expose several methods per type. !

!MDDSEncoder class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/30/2014 14:04'!
on: aReadStream
	^self new stream: aReadStream; yourself.! !

!MDDSEncoder methodsFor: 'encoding' stamp: 'SantiagoBragagnolo 10/20/2014 22:05'!
encodeArray: anArray of: aRelatedType
	self encodeUint32: anArray size.
	self encodeFixedLenghtArray: anArray of: aRelatedType! !

!MDDSEncoder methodsFor: 'encoding' stamp: 'SantiagoBragagnolo 10/20/2014 22:05'!
encodeBoolean: aBoolean
	^ aBoolean
		ifTrue: [ stream nextPut: 1 ]
		ifFalse: [ stream nextPut: 0 ]! !

!MDDSEncoder methodsFor: 'encoding' stamp: 'SantiagoBragagnolo 10/20/2014 22:05'!
encodeByte: aByte
	stream nextPut: aByte! !

!MDDSEncoder methodsFor: 'encoding' stamp: 'SantiagoBragagnolo 10/9/2012 12:13'!
encodeBytes: aCollection
	stream nextPutAll: aCollection.! !

!MDDSEncoder methodsFor: 'encoding' stamp: 'SantiagoBragagnolo 1/23/2013 20:40'!
encodeDuration: aDuration
	self encodeUint32: aDuration secondsField.
	self encodeUint32: aDuration nanoSeconds.
	
! !

!MDDSEncoder methodsFor: 'encoding' stamp: 'SantiagoBragagnolo 10/20/2014 22:06'!
encodeFixedLenghtArray: anArray of: aRelatedType
	anArray do: [ :item | aRelatedType serialize: item into: self ]! !

!MDDSEncoder methodsFor: 'encoding' stamp: 'SantiagoBragagnolo 10/20/2014 22:06'!
encodeInt16: aSmallInteger
	"Write a signed integer to the next 4 bytes"

	| pos topMagnitude |
	topMagnitude := (2 raisedTo: 8 * 2) / 2.
	self verifyIf: aSmallInteger isBetween: topMagnitude * -1 and: topMagnitude.
	pos := aSmallInteger < 0
		ifTrue: [ (0 - aSmallInteger) bitInvert16 + 1 ]
		ifFalse: [ aSmallInteger ].
	1 to: 2 do: [ :i | stream nextPut: (pos digitAt: i) ]! !

!MDDSEncoder methodsFor: 'encoding' stamp: 'SantiagoBragagnolo 10/20/2014 22:07'!
encodeInt32: aSmallInteger
	"Write a signed integer to the next 4 bytes"

	| pos topMagnitude |
	topMagnitude := (2 raisedTo: 8 * 4) / 2.
	self verifyIf: aSmallInteger isBetween: topMagnitude * -1 and: topMagnitude.
	pos := aSmallInteger < 0
		ifTrue: [ (0 - aSmallInteger) bitInvert32 + 1 ]
		ifFalse: [ aSmallInteger ].
	1 to: 4 do: [ :i | stream nextPut: (pos digitAt: i) ]! !

!MDDSEncoder methodsFor: 'encoding' stamp: 'SantiagoBragagnolo 10/20/2014 22:06'!
encodeInt64: aSmallInteger
	"Write a signed integer to the next 4 bytes"

	| pos topMagnitude |
	topMagnitude := (2 raisedTo: 8 * 8) / 2.
	self verifyIf: aSmallInteger isBetween: topMagnitude * -1 and: topMagnitude.
	pos := aSmallInteger < 0
		ifTrue: [ (0 - aSmallInteger) bitInvert64 + 1 ]
		ifFalse: [ aSmallInteger ].
	1 to: 8 do: [ :i | stream nextPut: (pos digitAt: i) ]! !

!MDDSEncoder methodsFor: 'encoding' stamp: 'SantiagoBragagnolo 10/20/2014 22:07'!
encodeInt8: aSmallInteger
	"Write a signed integer to the next byte"

	| val topMagnitude |
	topMagnitude := (2 raisedTo: 8) / 2.
	self verifyIf: aSmallInteger isBetween: topMagnitude * -1 and: topMagnitude.
	(aSmallInteger >= 0 and: [ aSmallInteger < 128 ])
		ifTrue: [ val := aSmallInteger ].
	(aSmallInteger < 0 and: [ aSmallInteger > -129 ])
		ifTrue: [ val := aSmallInteger abs bitInvert8 + 1 ].
	val ifNil: [ self error: 'out of bounds.' ].
	^ self encodeByte: val! !

!MDDSEncoder methodsFor: 'encoding' stamp: 'SantiagoBragagnolo 10/20/2014 22:07'!
encodeString: aString
	self encodeUint32: aString size.
	self encodeBytes: aString asByteArray! !

!MDDSEncoder methodsFor: 'encoding' stamp: 'SantiagoBragagnolo 10/20/2014 22:07'!
encodeTime: aTime
	| time |
	time := aTime.
	aTime isSymbol
		ifTrue: [ time := MDDSTimestamp perform: aTime ].
	(aTime isKindOf: DateAndTime)
		ifTrue: [
			
			time := MDDSTimestamp new
				timestamp: aTime;
				yourself
			].
	self encodeUint32: time secondsUTC.
	self encodeUint32: time nanoSeconds! !

!MDDSEncoder methodsFor: 'encoding' stamp: 'SantiagoBragagnolo 10/20/2014 22:07'!
encodeUint16: aSmallInteger
	"Append to the receiver an Integer as the next two bytes."

	| array a b topMagnitude |
	topMagnitude := 2 raisedTo: 8 * 2.
	self verifyIf: aSmallInteger isBetween: 0 and: topMagnitude.
	a := aSmallInteger bitShift: -8.
	b := aSmallInteger bitAnd: 255.
	array := ByteArray new , b asByteArray , a asByteArray.
	stream nextPutAll: array! !

!MDDSEncoder methodsFor: 'encoding' stamp: 'SantiagoBragagnolo 10/20/2014 22:07'!
encodeUint32: aSmallInteger
	| topMagnitude |
	topMagnitude := 2 raisedTo: 8 * 4.
	self verifyIf: aSmallInteger isBetween: 0 and: topMagnitude.	"Append to the receiver an Integer as the next 4 bytes."
	1 to: 4 do: [ :i | stream nextPut: (aSmallInteger digitAt: i) ]! !

!MDDSEncoder methodsFor: 'encoding' stamp: 'SantiagoBragagnolo 10/20/2014 22:07'!
encodeUint64: aNumber
	| val topMagnitude |
	topMagnitude := 2 raisedTo: 8 * 8.
	self verifyIf: aNumber isBetween: 0 and: topMagnitude.
	val := aNumber asByteArray.
	val := (ByteArray new: 8 - val size) , val.
	val := val reversed.
	stream nextPutAll: val! !

!MDDSEncoder methodsFor: 'encoding' stamp: 'SantiagoBragagnolo 10/20/2014 22:07'!
encodeUint8: aSmallInteger
	"Write a signed integer to the next byte"

	| topMagnitude |
	topMagnitude := 2 raisedTo: 8.
	self verifyIf: aSmallInteger isBetween: 0 and: topMagnitude.
	^ self encodeByte: aSmallInteger! !

!MDDSEncoder methodsFor: 'encoding' stamp: 'SantiagoBragagnolo 10/20/2014 22:07'!
encodefloat32: aFloat
	| encoded |
	encoded := aFloat asFloat asIEEE32BitWord asByteArray reversed.
	encoded := (ByteArray new: 4 - encoded size) , encoded.
	stream nextPutAll: encoded! !

!MDDSEncoder methodsFor: 'encoding' stamp: 'SantiagoBragagnolo 1/30/2013 16:04'!
encodefloat64: aFloat64
	| encoded aFloat |
	aFloat := aFloat64 asFloat.
	encoded := ByteArray new: 8.
	
	encoded at:1 put: ((aFloat basicAt:2) digitAt: 1).
	encoded at:2 put: ((aFloat basicAt:2) digitAt: 2).
	encoded at:3 put: ((aFloat basicAt:2) digitAt: 3).
	encoded at:4 put: ((aFloat basicAt:2) digitAt: 4).
	
	encoded at:5 put: ((aFloat basicAt:1) digitAt: 1).
	encoded at:6 put: ((aFloat basicAt:1) digitAt: 2).
	encoded at:7 put: ((aFloat basicAt:1) digitAt: 3).
	encoded at:8 put: ((aFloat basicAt:1) digitAt: 4).
	
	
	stream nextPutAll: encoded.
	
	
	"encoded := ByteArray readHexFrom: (PDRConverter as64BitsHexStringFromFloat: aFloat).
	stream nextPutAll: encoded."! !

!MDDSEncoder methodsFor: 'serialize' stamp: 'SantiagoBragagnolo 10/20/2014 22:08'!
flush
	stream flush! !

!MDDSEncoder methodsFor: 'encoding' stamp: 'SantiagoBragagnolo 10/1/2014 12:17'!
resetBuffers
	stream resetBuffers.! !

!MDDSEncoder methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/9/2012 11:07'!
stream: aStream 
	stream := aStream.
	
! !

!MDDSEncoder methodsFor: 'encoding' stamp: 'SantiagoBragagnolo 10/20/2014 22:08'!
verifyIf: aNumber isBetween: aLower and: aHigher
	" the implementation of x between: a and: b  is  x belongs to (a, b). But i need x belongs to [a, b]. Thats why i use (a-1; b+1)"

	(aNumber between: aLower and: aHigher)
		ifFalse: [ self error: ' number should be in the proper interval ' ]! !

MDDSEncoder subclass: #MDDSHeaderEncoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Encoding'!

!MDDSHeaderEncoder commentStamp: 'SantiagoBragagnolo 10/1/2014 16:24' prior: 0!
A MDDSHeaderEncoder is specific decoder that is used for header logic. It is not defined in the main decoder because is kind of addon, since the type system is a bit different. Then, in order to keep the rest clear all this logic is encapsulated!

!MDDSHeaderEncoder class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/1/2014 16:12'!
fieldNameSeparator
	^61 "$=  asInteger"! !

!MDDSHeaderEncoder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:08'!
encodeHeader: aHeader
	aHeader attributes do: [ :attr | self encodeHeaderAttribute: attr ]! !

!MDDSHeaderEncoder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:08'!
encodeHeaderAttribute: aHeaderAttribute
	| rawValue |
	rawValue := aHeaderAttribute name asByteArray , self class fieldNameSeparator asByteArray
		, aHeaderAttribute value asByteArray.
	self encodeUint32: rawValue size.
	self encodeBytes: rawValue! !

Object subclass: #MDDSEntity
	instanceVariableNames: 'domain name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSEntity commentStamp: 'SantiagoBragagnolo 9/10/2014 20:13' prior: 0!
Any entity that has to do with the domain, has a domain and name for sure. !

MDDSEntity subclass: #MDDSDomainParticipant
	instanceVariableNames: 'ip'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSDomainParticipant commentStamp: 'SantiagoBragagnolo 9/12/2014 19:51' prior: 0!
A MDDSDomainParticipant is an entity that participates in the DDS as writer or reader!

!MDDSDomainParticipant class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/9/2014 20:05'!
domain: aDomain name: aName ip: anIp
	^ (super domain: aDomain name: aName) ip: (NetNameResolver addressFromString: anIp); yourself.! !

!MDDSDomainParticipant methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/9/2014 20:17'!
ip
	^ ip! !

!MDDSDomainParticipant methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/9/2014 20:17'!
ip: anIp
	ip := anIp.! !

!MDDSDomainParticipant methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/6/2014 16:21'!
obtainPortFor: aProtocol
	^ domain obtainPort.! !

!MDDSDomainParticipant methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/6/2014 16:21'!
protocols
	^ domain protocols! !

MDDSEntity subclass: #MDDSDomainParticipantMirror
	instanceVariableNames: 'participant'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Reflection'!

!MDDSDomainParticipantMirror commentStamp: 'SantiagoBragagnolo 9/8/2014 19:11' prior: 0!
This class is the decription of a participant in our system in terms of communication: name, ip/port, etc!

!MDDSDomainParticipantMirror class methodsFor: 'constructor' stamp: 'SantiagoBragagnolo 9/12/2014 21:16'!
domain: aDomain name: aName participant: aMDDSParticipant
	^ (self domain: aDomain name: aName )participant: aMDDSParticipant ; yourself.! !

!MDDSDomainParticipantMirror methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/18/2014 16:40'!
domain
	^ participant domain! !

!MDDSDomainParticipantMirror methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/12/2014 21:12'!
participant
	^ participant! !

!MDDSDomainParticipantMirror methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/12/2014 21:11'!
participant: aMDDSDomainParticipant 
	participant := aMDDSDomainParticipant! !

!MDDSDomainParticipantMirror methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/6/2014 16:20'!
protocols 
	^ participant protocols! !

!MDDSDomainParticipantMirror methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/17/2014 11:11'!
publicationForTopic: aTopic
	^ aTopic publications detect: [ :s | s participant = participant ]. 
	! !

!MDDSDomainParticipantMirror methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/17/2014 11:12'!
publicationForTopicNamed: aTopicName
	^ self publicationForTopic: (participant domain findTopicByName: aTopicName)! !

!MDDSDomainParticipantMirror methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/17/2014 10:39'!
publications
	^ participant domain topics
		inject: Set new
		into: [ :set :topic | 
			set addAll: (topic publications select: [ :s | s participant = participant ]).
			set ]! !

!MDDSDomainParticipantMirror methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/20/2014 22:34'!
publishedTopics
	^ participant domain topics select: [ :t | t publications anySatisfy: [ :s | s participant = participant ] ]! !

!MDDSDomainParticipantMirror methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/20/2014 22:34'!
subscribedTopics
	^ participant domain topics select: [ :t | t subscriptions anySatisfy: [ :s | s participant = participant ] ]! !

!MDDSEntity class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/10/2014 23:12'!
domain: aDomain name: aName
	^ self new name: aName ; domain: aDomain; yourself.! !

!MDDSEntity class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/10/2014 23:13'!
named: aName
	^ self new name: aName ;yourself.! !

!MDDSEntity methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/11/2014 20:43'!
asString
	^ self class name,  '  ', name.! !

!MDDSEntity methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/9/2014 20:36'!
domain
	^ domain! !

!MDDSEntity methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/10/2014 20:12'!
domain: aDDSDomain
	domain := aDDSDomain.! !

!MDDSEntity methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/10/2014 20:12'!
name
	^ name.! !

!MDDSEntity methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/10/2014 20:12'!
name: aTopicName
	name := aTopicName.! !

!MDDSEntity methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:11'!
printOn: aStream
	self asString printOn: aStream! !

MDDSEntity subclass: #MDDSParticipantDescriptor
	instanceVariableNames: 'uri participant'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Reflection'!

!MDDSParticipantDescriptor commentStamp: 'SantiagoBragagnolo 11/17/2014 15:54' prior: 0!
A MDDSParticipantDescriptor is an object that tracks events and data and describe an existant participant. The related participant is a proxy to the real participant. !

!MDDSParticipantDescriptor class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 2/11/2015 11:54'!
domain: aDomain name: aParticipantName uri: anUri.
	^ (super  domain: aDomain name: aParticipantName ) uri: anUri; yourself! !

!MDDSParticipantDescriptor methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 11/13/2014 10:01'!
participant
	^ participant ifNil: [  participant := domain createParticipantFor: self ] .! !

!MDDSParticipantDescriptor methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/29/2014 19:03'!
uri
	^ uri! !

!MDDSParticipantDescriptor methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/29/2014 19:03'!
uri: anObject
	uri := anObject! !

MDDSEntity subclass: #MDDSTopic
	instanceVariableNames: 'type subscriber publisher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSTopic commentStamp: 'SantiagoBragagnolo 9/10/2014 20:42' prior: 0!
Real topic. This topic has the ability to act as a topic it self. Register it, ask for publishers and subscribers.!

!MDDSTopic class methodsFor: 'constructor' stamp: 'SantiagoBragagnolo 2/8/2015 22:55'!
domain: aDomain name: aName type: aType 
	^ self new name: aName; type: aType; domain: aDomain; yourself.! !

!MDDSTopic class methodsFor: 'constructor' stamp: 'SantiagoBragagnolo 10/13/2014 14:46'!
name: aName type: aTypeName 
	self halt. " Does any one use this "
	^ self new name: aName; type: aTypeName; yourself.! !

!MDDSTopic methodsFor: 'testing' stamp: 'SantiagoBragagnolo 11/15/2014 18:59'!
hasPublications
	^ publisher ifNil: [ false ] ifNotNil: [ self publications size > 0 ]! !

!MDDSTopic methodsFor: 'testing' stamp: 'SantiagoBragagnolo 11/15/2014 18:59'!
hasSubscriptions
	^ subscriber ifNil: [ false ] ifNotNil: [ self subscriptions size > 0 ]! !

!MDDSTopic methodsFor: 'testing' stamp: 'SantiagoBragagnolo 10/20/2014 22:12'!
isRegistered
	^ self subscriber isRegistered or: [ self publisher isRegistered ]! !

!MDDSTopic methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/14/2014 15:03'!
noticeConnectionWith: aHeader
	type isTypePlaceHolder ifTrue: [ 
		" Is a type holder "
		type := type resolveRealTypeFrom: aHeader 	
	]! !

!MDDSTopic methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:12'!
publications
	^ publisher ifNotNil: [ publisher publications ] ifNil: [ Set new ]! !

!MDDSTopic methodsFor: 'creation' stamp: 'SantiagoBragagnolo 10/20/2014 22:12'!
publisher
	^ publisher ifNil: [ publisher := MDDSPublisher domain: domain named: name , '-publisher' on: self ]! !

!MDDSTopic methodsFor: 'subscription' stamp: 'SantiagoBragagnolo 10/20/2014 22:12'!
subscriber
	^ subscriber ifNil: [ subscriber := domain subscriberFor: self ]! !

!MDDSTopic methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:11'!
subscriptions
	^ subscriber ifNotNil: [ subscriber subscriptions ] ifNil: [ Set new ]! !

!MDDSTopic methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/10/2014 23:11'!
type	
	^ type.! !

!MDDSTopic methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/10/2014 23:11'!
type: aType
	type := aType! !

MDDSEntity subclass: #MDDSTopicDescriptor
	instanceVariableNames: 'type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Reflection'!

!MDDSTopicDescriptor commentStamp: 'SantiagoBragagnolo 9/15/2014 19:33' prior: 0!
A MDDSTopicDescriptor is description that defines a topic. Name, type, etc. It allows also to create a topic.!

!MDDSTopicDescriptor class methodsFor: 'constructor' stamp: 'SantiagoBragagnolo 11/27/2014 16:12'!
domain: aDomain name: aName type: aTypeName 
	^ self new name: aName; type: aTypeName;  domain: aDomain ; yourself.! !

!MDDSTopicDescriptor class methodsFor: 'constructor' stamp: 'SantiagoBragagnolo 9/10/2014 19:44'!
name: aName type: aTypeName 
	^ self new name: aName; type: aTypeName; yourself.! !

!MDDSTopicDescriptor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:35'!
asString
	^ '{1}:{2}@{3}'
		format:
			{name.
			type.
			' domain'}! !

!MDDSTopicDescriptor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:35'!
createTopic
	^ domain createTopicNamed: name type: type createType! !

!MDDSTopicDescriptor methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/20/2014 22:35'!
domain: aDomain
	type domain: aDomain.
	^ super domain: aDomain! !

!MDDSTopicDescriptor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/17/2014 14:29'!
participants
	self shouldBeImplemented.! !

!MDDSTopicDescriptor methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 11/17/2014 14:27'!
topic
	^ self! !

!MDDSTopicDescriptor methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/10/2014 19:58'!
type
	^ type! !

!MDDSTopicDescriptor methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/10/2014 19:34'!
type: aTopicType
	type := aTopicType! !

MDDSEntity subclass: #MDDSTopicInteractor
	instanceVariableNames: 'topic'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSTopicInteractor commentStamp: 'SantiagoBragagnolo 9/11/2014 21:06' prior: 0!
This is an abstract class for objects that are bidirectionally related with topics, under the relation of usage or interaction.!

MDDSTopicInteractor subclass: #MDDSPublisher
	instanceVariableNames: 'publications'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSPublisher commentStamp: 'SantiagoBragagnolo 9/11/2014 20:53' prior: 0!
Object that manage the publishing to a topic. Used to publish
publisher := topic publisher.

publisher publish:  something.
publisher publish: [ : t | t fillupWith: something ].

topic publish: something.

There is just one publisher per topic in an image. It is thread safe!

!MDDSPublisher methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/3/2014 19:17'!
initialize
	publications := Set new.! !

!MDDSPublisher methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/15/2014 19:21'!
isRegistered
	^ false.! !

!MDDSPublisher methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/4/2014 19:38'!
obtainPort
	^ domain obtainPort.! !

!MDDSPublisher methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:12'!
publicationFor: aParticipant ifNone: aBlock
	^ publications detect: [ :each | each participant = aParticipant ] ifNone: aBlock! !

!MDDSPublisher methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/3/2014 19:41'!
publications
	^ publications! !

!MDDSPublisher methodsFor: 'creation' stamp: 'SantiagoBragagnolo 11/13/2014 20:58'!
publishing: aMDDSDomainParticipant
	^ publications
		detect: [ :each | each isPublishing: aMDDSDomainParticipant ]
		ifNone: [ 
			| publication |
			publication := domain createPublicationFor: aMDDSDomainParticipant with: topic type.
			publications add: publication.
			publication noteIsRegisteredIn: self.			
			domain note: (MDDSTopicAnnouncement participant: aMDDSDomainParticipant isNowPublishingOn: self through: publication).
			publication ]! !

!MDDSPublisher methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/28/2014 15:36'!
removePublication: aPublication
	| announcement |
	publications remove: aPublication ifAbsent: [  ^ self  ] .
	announcement := MDDSTopicAnnouncement
		participant: aPublication participant
		isNotPublishingAnymoreOn: self
		through: aPublication.
	domain note: announcement! !

!MDDSPublisher methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/28/2014 12:31'!
stopPublishing
	publications do: [ :p | self stopPublishing: p ]! !

!MDDSPublisher methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/13/2014 23:28'!
stopPublishing: aPublication
	aPublication noteIsNotRegisteredAnymore.
	self removePublication: aPublication! !

!MDDSPublisher methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/28/2014 16:48'!
stopPublishingParticipant: aParticipant
	| publication | 
	publication := self publicationFor: aParticipant ifNone: [ self error: ' There is no publication to stop for the given participant' ].
	self stopPublishing: publication.! !

MDDSTopicInteractor subclass: #MDDSSubscriber
	instanceVariableNames: 'subscriptions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSSubscriber commentStamp: 'SantiagoBragagnolo 9/11/2014 21:01' prior: 0!
Represents the subscription to a topic. 
There is just one subscriber per topic, It handles allt the needed subscriptions.

subscriber := topic subscriber.
subscription := subscriber onRead: [ : val |  ] onFailure: [ :fail | ] onStop:["" ].

subcription := subcriber subscribe.

subscription := topic onRead: [ : val |  ]; onFailure: [ :fail | ]; onStop:["" ].


subscription cancel.
				
			
topic!

!MDDSSubscriber methodsFor: 'subscription' stamp: 'SantiagoBragagnolo 3/5/2015 15:15'!
forParticipant: aParticipant
	^ self
		registerIfNeeded: aParticipant
		creatingSubscriptionWith: [ 
			(domain createSubscriptionFor: aParticipant)
				onRead: [ :m |  ];
				yourself ]! !

!MDDSSubscriber methodsFor: 'subscription' stamp: 'SantiagoBragagnolo 10/27/2014 21:38'!
forParticipant: aParticipant onRead: onRead
	^ self
		registerIfNeeded: aParticipant
		creatingSubscriptionWith: [ 
			(domain createSubscriptionFor: aParticipant)
				onRead: onRead;
				yourself ]! !

!MDDSSubscriber methodsFor: 'creation' stamp: 'SantiagoBragagnolo 10/27/2014 21:38'!
forParticipant: aParticipant onRead: onRead onFailure: onFailure
	^ self
		registerIfNeeded: aParticipant
		creatingSubscriptionWith: [ 
			(domain createSubscriptionFor: aParticipant)
				onRead: onRead;
				onFailure: onFailure;
				yourself ]! !

!MDDSSubscriber methodsFor: 'subscription' stamp: 'SantiagoBragagnolo 10/27/2014 21:35'!
forParticipant: aParticipant onRead: onRead onFailure: onFailure onStop: onStop
	^ self
		registerIfNeeded: aParticipant
		creatingSubscriptionWith: [ 
			(domain createSubscriptionFor: aParticipant)
				onRead: onRead;
				onFailure: onFailure;
				onStop: onStop;
				yourself ]! !

!MDDSSubscriber methodsFor: 'initialization' stamp: 'SantiagoBragagnolo 10/27/2014 22:12'!
initialize
	super initialize.
	subscriptions := Set new.! !

!MDDSSubscriber methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/15/2014 19:20'!
isRegistered
	^ subscriptions isEmpty not.! !

!MDDSSubscriber methodsFor: 'registry' stamp: 'SantiagoBragagnolo 10/28/2014 15:18'!
register: aSubscription
	subscriptions add: aSubscription.
	domain note: (MDDSTopicAnnouncement participant: aSubscription participant isNowSubscribedTo: self with: aSubscription ).
	^ aSubscription! !

!MDDSSubscriber methodsFor: 'private' stamp: 'SantiagoBragagnolo 10/27/2014 23:32'!
registerIfNeeded: aParticipant creatingSubscriptionWith: aBlock
	^ self subscriptionFor: aParticipant ifNone: [ self register: aBlock value ]! !

!MDDSSubscriber methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/27/2014 23:48'!
subscribe: aParticipant
	^ self registerIfNeeded: aParticipant creatingSubscriptionWith: [ domain createSubscriptionFor: aParticipant ]! !

!MDDSSubscriber methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/27/2014 21:54'!
subscriptionFor: aParticipant 
	^ self subscriptionFor: aParticipant ifNone: [ self error: 'There is not subscription for the given participant' ]. ! !

!MDDSSubscriber methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/27/2014 19:41'!
subscriptionFor: aParticipant ifNone: aBlock 
	^ subscriptions detect: [ :each | each participant = aParticipant ] ifNone: aBlock ! !

!MDDSSubscriber methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/20/2014 22:13'!
subscriptions
	^ subscriptions! !

!MDDSSubscriber methodsFor: 'registry' stamp: 'SantiagoBragagnolo 11/28/2014 12:44'!
unregister: aSubscription
	| announcement |
	subscriptions remove: aSubscription.
	announcement := MDDSTopicAnnouncement
		participant: aSubscription participant
		isNotSubscribedAnymoreTo: self
		with: aSubscription.
	domain note: announcement.
	aSubscription destroy.
! !

!MDDSSubscriber methodsFor: 'registry' stamp: 'SantiagoBragagnolo 11/28/2014 12:39'!
unregisterAll
	subscriptions do: [ :s | self unregister: s ].! !

!MDDSSubscriber methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/29/2014 18:48'!
unsubscribe: aParticipant
	^ self unregister: (self subscriptionFor: aParticipant ifNone: [ self error: ' There is not any subscription for the given Participant '])! !

!MDDSTopicInteractor class methodsFor: 'constructor' stamp: 'SantiagoBragagnolo 9/11/2014 21:06'!
domain: aMDDSDomain named: aName on: aMDDSTopic 
	^ (super domain: aMDDSDomain name: aName) topic: aMDDSTopic; yourself. ! !

!MDDSTopicInteractor methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/12/2014 19:38'!
topic
	^ topic.! !

!MDDSTopicInteractor methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/11/2014 21:06'!
topic: aMDDSTopic 
	topic := aMDDSTopic.! !

MDDSEntity subclass: #MDDSType
	instanceVariableNames: 'md5sum marshaller plainDefinition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSType commentStamp: 'SantiagoBragagnolo 9/10/2014 20:43' prior: 0!
This is a type it self, it has the ability to load it definition and define marshaling/ unmarshaling objects!

!MDDSType class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/3/2014 15:47'!
domain: aDomain name: aName marshaller: aTypeMarshaller md5sum: aSum
	^ (self domain: aDomain name: aName) marshaller: aTypeMarshaller; md5sum: aSum; yourself.! !

!MDDSType methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 11/14/2014 14:50'!
isTypePlaceHolder
	^ false.! !

!MDDSType methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/3/2014 15:49'!
marshaller
	^ marshaller! !

!MDDSType methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/3/2014 15:47'!
marshaller: aTypeMarshaller
	marshaller := aTypeMarshaller! !

!MDDSType methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 11/18/2014 23:04'!
md5sum
	^ md5sum ifNil: ''! !

!MDDSType methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/1/2014 23:18'!
md5sum: aSum
	md5sum := aSum! !

!MDDSType methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 11/18/2014 16:04'!
plainDefinition
	^ plainDefinition ifNil: [ plainDefinition := domain plainTypeDefinitionFor: self ]! !

!MDDSType methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 11/23/2014 23:20'!
verify: aTypeName md5: aMd5Sum
	^ aTypeName isEmpty
		or: [ aMd5Sum isEmpty or: [ self name = aTypeName and: [ self md5sum isEmpty  or: [ self md5sum = aMd5Sum ] ] ] ]! !

MDDSEntity subclass: #MDDSTypeDescriptor
	instanceVariableNames: 'definition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Reflection'!

!MDDSTypeDescriptor commentStamp: 'SantiagoBragagnolo 11/14/2014 14:58' prior: 0!
A publisher  subscriber protocol is based on the sharing and publication of types. This type represent the type idea, but not it definition or it marshaller. 

!

!MDDSTypeDescriptor class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/14/2014 14:53'!
isUnknown: aTypeDescriptor
	^ self unknownWildcard = aTypeDescriptor name! !

!MDDSTypeDescriptor class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/14/2014 14:51'!
unknownTypeFor: aDomain
	^ super domain: aDomain name: self unknownWildcard.! !

!MDDSTypeDescriptor class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/14/2014 14:52'!
unknownWildcard
	^ #*! !

!MDDSTypeDescriptor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 12/1/2014 13:56'!
createType
	^ (self isUnknown or: [ self isUndefined ])
		ifTrue: [ domain createTypePlaceHolder: name asString ]
		ifFalse: [ domain createTypeNamed: name asString definedBy: self definition ]! !

!MDDSTypeDescriptor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:35'!
definition
	^ definition ifNil: [ definition := domain typeDefinition: name ]! !

!MDDSTypeDescriptor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/29/2014 23:58'!
describes: aType
	^ name = aType name.! !

!MDDSTypeDescriptor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 2/13/2015 21:53'!
domain: aDomain	
	super domain: aDomain.! !

!MDDSTypeDescriptor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 12/1/2014 13:55'!
isUndefined
	^  (domain isTypeDefined: name) not ! !

!MDDSTypeDescriptor methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 12/1/2014 13:55'!
isUnknown
	^ self class isUnknown: self! !

MDDSEntity subclass: #MDDSTypePlaceHolder
	instanceVariableNames: 'md5sum'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSTypePlaceHolder commentStamp: 'SantiagoBragagnolo 11/14/2014 14:49' prior: 0!
Some times the topic has not a type because the user  do not know it. In this cases, the topic will be configured with a TypePlaceHolder. This is a place holder for the type.  And during the first connection the topic should be informed and inform to the type holder in order to become it a real type. !

!MDDSTypePlaceHolder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/14/2014 14:49'!
isTypePlaceHolder
	^ true ! !

!MDDSTypePlaceHolder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 12/1/2014 14:03'!
isUndefined
	^ (name = MDDSTypeDescriptor unknownWildcard) not! !

!MDDSTypePlaceHolder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/18/2014 23:18'!
md5sum
	^ md5sum ifNil: ''! !

!MDDSTypePlaceHolder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/18/2014 23:18'!
plainDefinition
	^ ''! !

!MDDSTypePlaceHolder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/14/2014 14:43'!
resolveRealTypeFrom: aHeader
	^ domain
		createTypeNamed: name
		definedBy: (domain loadTypeDefinitionNamed: name definedFromString: aHeader message_definition)! !

!MDDSTypePlaceHolder methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 12/1/2014 14:03'!
verify: aTypeName md5: aMd5Sum
	(self isUndefined and: [ name = aTypeName ])
		ifTrue: [ self assert: name = aTypeName ]
		ifFalse: [ name := aTypeName ].
	md5sum := aMd5Sum.
	^ true! !

Object subclass: #MDDSHeaderAtribute
	uses: TEquality
	instanceVariableNames: 'name value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSHeaderAtribute commentStamp: 'SantiagoBragagnolo 10/6/2014 18:35' prior: 0!
a header attribute is a part of a header. Each field is represented with a a header attribute.!

MDDSHeaderAtribute class
	uses: TEquality classTrait
	instanceVariableNames: ''!

!MDDSHeaderAtribute class methodsFor: 'constructor' stamp: 'SantiagoBragagnolo 10/1/2014 11:51'!
name: aName value: aValue
	^ self new name: aName; value: aValue; yourself.! !

!MDDSHeaderAtribute methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/1/2014 14:32'!
asString
	^ '{1}={2}' format: { name . value  }.! !

!MDDSHeaderAtribute methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/1/2014 11:50'!
name
	^ name! !

!MDDSHeaderAtribute methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/1/2014 11:50'!
name: anObject
	name := anObject! !

!MDDSHeaderAtribute methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/1/2014 14:30'!
printOn: aStream
	self asString printOn: aStream! !

!MDDSHeaderAtribute methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/1/2014 11:50'!
value
	^ value! !

!MDDSHeaderAtribute methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/1/2014 11:50'!
value: anObject
	value := anObject! !

Object subclass: #MDDSItemDefinition
	instanceVariableNames: 'name typeDefiniton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-TypesDefinition'!

!MDDSItemDefinition commentStamp: '<historical>' prior: 0!
Generic part of a type definition.!

MDDSItemDefinition subclass: #MDDSConstantDefinition
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-TypesDefinition'!

!MDDSConstantDefinition commentStamp: '<historical>' prior: 0!
A PhaROSConstantDefinition  Is an constant usable in the type that is part of. It has name, type and value.!

!MDDSConstantDefinition class methodsFor: 'instance creation' stamp: 'SantiagoBragagnolo 9/30/2014 11:21'!
name: aName typedAs: aTypeDefinition withValue: aValue 
	^ self new name: aName; type: aTypeDefinition; value: aValue; yourself! !

!MDDSConstantDefinition methodsFor: 'converting' stamp: 'SantiagoBragagnolo 10/20/2014 22:36'!
classAccessor
	^ ('{1}' , String crlf , String tab , '^{2}' , String crlf) translated
		format:
			{(name asLowercase).
			(self valueForGeneration)}! !

!MDDSConstantDefinition methodsFor: 'testing' stamp: 'SantiagoBragagnolo 2/8/2014 12:10'!
isConstant 	
	^ true! !

!MDDSConstantDefinition methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 2/8/2014 11:55'!
name: aName
	name:= aName! !

!MDDSConstantDefinition methodsFor: 'converting' stamp: 'SantiagoBragagnolo 2/13/2015 22:06'!
rosdefinition 
	^ ' {1} {2}={3}' format: { self typeDefinition typeName . name . self valueForGeneration }.! !

!MDDSConstantDefinition methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 2/8/2014 11:56'!
value: aValue
	value:= aValue.! !

!MDDSConstantDefinition methodsFor: 'converting' stamp: 'SantiagoBragagnolo 10/20/2014 22:36'!
valueForGeneration
	^ ((self typeDefinition isKindOf: MDDSBasicTypeDefinition)
		and: [ self typeDefinition typeSerializer isKindOf: MDDSStringType ])
		ifTrue: [ '''{1}''' format: {(value asString)} ]
		ifFalse: [ value asString ]! !

MDDSItemDefinition subclass: #MDDSFieldDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-TypesDefinition'!

!MDDSFieldDefinition commentStamp: '<historical>' prior: 0!
PhaROSFieldDefinition Is an entry of a type. It has name and type.!

!MDDSFieldDefinition methodsFor: 'converting' stamp: 'SantiagoBragagnolo 2/8/2014 18:52'!
getter 
	^ ('{1}' , String crlf, String tab, '^ self getAt: #{1}. ', String crlf) translated format: { name}! !

!MDDSFieldDefinition methodsFor: 'converting' stamp: 'SantiagoBragagnolo 9/19/2014 19:34'!
hasToInstallHelper
	^ typeDefiniton isCollection! !

!MDDSFieldDefinition methodsFor: 'converting' stamp: 'SantiagoBragagnolo 2/8/2014 18:53'!
helper
	^ ('add{1}: aValue' , String crlf, String tab, '^ self {2} add: aValue. ', String crlf ) translated format: { (name capitalized copyFrom:1 to: name size -1 ) . name } ! !

!MDDSFieldDefinition methodsFor: 'converting' stamp: 'SantiagoBragagnolo 9/19/2014 19:38'!
initializer
	^  (String tab, ' self {1}: {2}. ', String crlf) translated format: { name . self type defaultValueString }! !

!MDDSFieldDefinition methodsFor: 'testing' stamp: 'SantiagoBragagnolo 2/8/2014 12:10'!
isField
	^ true! !

!MDDSFieldDefinition methodsFor: 'converting' stamp: 'SantiagoBragagnolo 2/13/2015 22:06'!
rosdefinition 
	^ ' {1} {2}' format: {  self typeDefinition typeName . name  }.! !

!MDDSFieldDefinition methodsFor: 'converting' stamp: 'SantiagoBragagnolo 2/8/2014 18:52'!
setter
	^ ('{1}: aValue' , String crlf, String tab, '^ self at: #{1} put: aValue. ', String crlf ) translated format: { name }! !

!MDDSItemDefinition class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/30/2014 11:13'!
name: aName type: aTypeDefinition
	^ self new name: aName; typeDefinition: aTypeDefinition; yourself.! !

!MDDSItemDefinition methodsFor: 'testing' stamp: 'SantiagoBragagnolo 2/8/2014 12:10'!
isConstant
	^ false! !

!MDDSItemDefinition methodsFor: 'testing' stamp: 'SantiagoBragagnolo 2/8/2014 12:09'!
isField
	^ false.! !

!MDDSItemDefinition methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 2/8/2014 12:12'!
name
	^ name! !

!MDDSItemDefinition methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 2/8/2014 12:08'!
name: aName
	name:= aName.! !

!MDDSItemDefinition methodsFor: 'converting' stamp: 'SantiagoBragagnolo 2/8/2014 16:44'!
rosdefinition
	^ self subclassResponsibility .! !

!MDDSItemDefinition methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/3/2014 15:45'!
type
	^ typeDefiniton typeBuilder buildTypeMarshaller.! !

!MDDSItemDefinition methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/19/2014 19:36'!
typeDefinition
	^ typeDefiniton.! !

!MDDSItemDefinition methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/20/2014 22:36'!
typeDefinition: aType
	self assert: (aType isKindOf: MDDSTypeBuilder) not.
	typeDefiniton := aType! !

Object subclass: #MDDSPortResolver
	instanceVariableNames: 'lastAssignedPort'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

MDDSPortResolver class
	instanceVariableNames: 'resolver'!

!MDDSPortResolver commentStamp: 'SantiagoBragagnolo 10/24/2014 16:33' prior: 0!
A MDDSPortResolver is an object that gives always a different number for ports. It should guarantee also that the port is free, but in the future!

MDDSPortResolver class
	instanceVariableNames: 'resolver'!

!MDDSPortResolver class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 12/1/2014 15:11'!
obtain	
	^ resolver ifNil: [ resolver := self new ].! !

!MDDSPortResolver methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/24/2014 11:57'!
initialize
	super initialize.
	lastAssignedPort := 9000 + ((Random seed: DateAndTime now asUnixTime) nextInt: 100)! !

!MDDSPortResolver methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/24/2014 16:33'!
obtainPort
	self flag: #GuaranteePortIsFree.
	lastAssignedPort := lastAssignedPort + ((Random seed: DateAndTime now asUnixTime) nextInt: 10).
	^ lastAssignedPort.! !

Object subclass: #MDDSProtoDomain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSProtoDomain commentStamp: 'SantiagoBragagnolo 9/11/2014 00:30' prior: 0!
A proto domain is not a Domain nor a DomainMirror. Is the base of both.!

MDDSProtoDomain subclass: #MDDSAbstractDomainMirror
	instanceVariableNames: 'domain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Reflection'!

!MDDSAbstractDomainMirror commentStamp: 'SantiagoBragagnolo 9/8/2014 18:55' prior: 0!
The domain mirror is a class the describes the current domain of data delivering !

!MDDSAbstractDomainMirror methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/11/2014 00:27'!
domain
	^ domain! !

!MDDSAbstractDomainMirror methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/22/2014 22:16'!
domain: aDomain	
	domain := aDomain.! !

!MDDSAbstractDomainMirror methodsFor: 'parameters' stamp: 'SantiagoBragagnolo 2/11/2015 10:36'!
findTopicDescriptorByName: aName ifFound: aFoundBlock ifNone: aBlock
	^ self topics detect: [ :t | t name = aName ] ifFound: aFoundBlock ifNone: aBlock! !

!MDDSAbstractDomainMirror methodsFor: 'parameters' stamp: 'SantiagoBragagnolo 2/11/2015 10:37'!
findTopicDescriptorByName: aName ifNone: aBlock
	^ self topics detect: [ :t | t name = aName ] ifNone: aBlock! !

!MDDSAbstractDomainMirror methodsFor: 'parameters' stamp: 'SantiagoBragagnolo 2/11/2015 10:36'!
findTopicDescriptorsByName: aName
	^ self findTopicDescriptorByName: aName ifNone: [ MDDSError signal: 'There is not topic named ' , aName ]! !

!MDDSAbstractDomainMirror methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/12/2014 19:57'!
reflectParticipant: aDomainParticipant
	self subclassResponsibility.! !

MDDSAbstractDomainMirror subclass: #MDDSRemoteDomainMirror
	instanceVariableNames: 'proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Reflection'!

!MDDSRemoteDomainMirror commentStamp: 'SantiagoBragagnolo 9/8/2014 19:20' prior: 0!
When the domain is described in other program (server), the domain mirror points to a remote location.!

!MDDSRemoteDomainMirror class methodsFor: 'constructor' stamp: 'SantiagoBragagnolo 9/12/2014 19:27'!
on: aDomainProxy
	^ self new proxy: aDomainProxy ; yourself.! !

!MDDSRemoteDomainMirror methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/20/2014 22:20'!
asString
	^ super asString , (' Remote ({1})' format: {proxy})! !

!MDDSRemoteDomainMirror methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/13/2014 20:03'!
createPublicationFor: aMDDSDomainParticipant with: aType
	^ proxy createPublicationFor: aMDDSDomainParticipant with: aType.! !

!MDDSRemoteDomainMirror methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 11/30/2014 15:27'!
destroy
	proxy
		ifNotNil: [ 
			proxy destroy.
			proxy := nil ]! !

!MDDSRemoteDomainMirror methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/14/2014 14:36'!
loadTypeDefinitionNamed: aName definedFromString: aStringDefinition
	^ proxy loadTypeDefinitionNamed: aName definedFromString: aStringDefinition! !

!MDDSRemoteDomainMirror methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/23/2014 21:15'!
notePublication: aMDDSIsPublishingAnnouncement
	| mirror |
	mirror := self reflectParticipant: aMDDSIsPublishingAnnouncement participant.
	^ proxy registerTopicPublisher: aMDDSIsPublishingAnnouncement publisher for: mirror in: domain.! !

!MDDSRemoteDomainMirror methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/23/2014 21:16'!
notePublicationFinished: aMDDSIsNotPublishingAnnouncement 
	| mirror |
	mirror := self reflectParticipant: aMDDSIsNotPublishingAnnouncement participant.
	^ proxy unregisterTopicPublisher: aMDDSIsNotPublishingAnnouncement publisher for: mirror! !

!MDDSRemoteDomainMirror methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/23/2014 21:17'!
noteSubscription: aMDDSIsSubscribedAnnouncement 
	| mirror |
	mirror := self reflectParticipant: aMDDSIsSubscribedAnnouncement participant.
	^ proxy registerTopicSubscriber: aMDDSIsSubscribedAnnouncement subscriber for: mirror in: domain.! !

!MDDSRemoteDomainMirror methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/23/2014 21:17'!
noteSubscriptionFinished: aMDDSIsNotSubscribedAnnouncement 
	| mirror |
	mirror := self reflectParticipant: aMDDSIsNotSubscribedAnnouncement participant.
	^ proxy unregisterTopicSubscriber: aMDDSIsNotSubscribedAnnouncement subscriber for: mirror! !

!MDDSRemoteDomainMirror methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/4/2014 19:40'!
obtainMirror
	^ proxy obtainMirror.! !

!MDDSRemoteDomainMirror methodsFor: 'port' stamp: 'SantiagoBragagnolo 10/6/2014 19:04'!
obtainPort
	^ proxy obtainPort.! !

!MDDSRemoteDomainMirror methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 2/8/2015 12:26'!
participants
	^ proxy participants! !

!MDDSRemoteDomainMirror methodsFor: 'abstract' stamp: 'SantiagoBragagnolo 11/18/2014 16:06'!
plainTypeDefinitionFor: aType
	^ proxy plainTypeDefinitionFor: aType! !

!MDDSRemoteDomainMirror methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/10/2014 19:49'!
printOn: aStream
	^ self asString printOn: aStream.! !

!MDDSRemoteDomainMirror methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/8/2014 19:21'!
proxy: aDomainProxy
	proxy := aDomainProxy ! !

!MDDSRemoteDomainMirror methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/12/2014 21:23'!
reflectParticipant: aDomainParticipant
	^ proxy reflectParticipant: aDomainParticipant.! !

!MDDSRemoteDomainMirror methodsFor: 'abstract' stamp: 'SantiagoBragagnolo 11/26/2014 20:42'!
registerTypeDefinition: aMDDSTypeDefinition
	^ proxy registerTypeDefinition: aMDDSTypeDefinition! !

!MDDSRemoteDomainMirror methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/21/2014 20:48'!
subscriberFor: aTopic
	^ proxy subscriberFor: aTopic in: domain.
! !

!MDDSRemoteDomainMirror methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/24/2014 12:37'!
topics
	^ proxy topics do: [ :topicMirror | topicMirror domain: domain ]! !

!MDDSRemoteDomainMirror methodsFor: 'abstract' stamp: 'SantiagoBragagnolo 11/19/2014 12:21'!
typeDefinition: aString ifAbsent: aBlock
	^ proxy typeDefinition: aString ifAbsent: aBlock.! !

MDDSProtoDomain subclass: #MDDSDomain
	instanceVariableNames: 'protocols createdTopics announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSDomain commentStamp: 'SantiagoBragagnolo 10/22/2014 21:54' prior: 0!
Domain representation where all the objects that go through are usable as the service and not as it description.!

!MDDSDomain methodsFor: 'adding' stamp: 'SantiagoBragagnolo 10/22/2014 21:52'!
addProtocol: aProtocolImplementation
	protocols add: aProtocolImplementation! !

!MDDSDomain methodsFor: 'abstract' stamp: 'SantiagoBragagnolo 11/13/2014 20:01'!
createPublicationFor: aMDDSDomainParticipant with: aType
	^ self subclassResponsibility! !

!MDDSDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/27/2014 20:11'!
createSubscriptionFor: aParticipant
	^ MDDSSubscription defaultForParticipant: aParticipant.! !

!MDDSDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/22/2014 21:52'!
createTopicNamed: aName type: aType
	^ createdTopics at: aName , aType name ifAbsentPut: [ MDDSTopic domain: self name: aName type: aType ]! !

!MDDSDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/24/2014 11:32'!
createTypeNamed: aName definedBy: aDefinition
	^ MDDSType
		domain: self
		name: aName
		marshaller: aDefinition typeBuilder buildTypeMarshaller
		md5sum: aDefinition md5sum! !

!MDDSDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/18/2014 23:13'!
createTypePlaceHolder:aName
	^ MDDSTypePlaceHolder domain: self name: aName! !

!MDDSDomain methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 11/30/2014 15:38'!
destroy
	createdTopics values
		do: [ :t | 
			t hasPublications
				ifTrue: [ t publisher stopPublishing ].
			t hasSubscriptions
				ifTrue: [ t subscriber unregisterAll  ].
			t domain: nil.
			t type domain: nil ].
	createdTopics removeAll.
	protocols removeAll.
	announcer := nil! !

!MDDSDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/27/2014 16:15'!
findOrRegisterTopicByName: aName
	^ self findOrRegisterTopicByName: aName type: MDDSTypeDescriptor unknownWildcard! !

!MDDSDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/30/2014 00:00'!
findOrRegisterTopicByName: aName type: aTypeName
	| found typeDesc |
	typeDesc := MDDSTypeDescriptor domain: self name: aTypeName.
	found := self
		findTopicByName: aName
		ifNone: [ (MDDSTopicDescriptor domain: self name: aName type: typeDesc) createTopic ].
	((typeDesc describes: found type) not and: [ found type isTypePlaceHolder ])
		ifTrue: [ found type: typeDesc createType ].
	^ found! !

!MDDSDomain methodsFor: 'initialization' stamp: 'SantiagoBragagnolo 10/27/2014 22:59'!
initialize
	super initialize.
	protocols := Set new.
	createdTopics := Dictionary new.
	announcer := Announcer new.
	
	self when: MDDSIsPublishingAnnouncement send: #notePublication: to: self. 
	self when: MDDSIsNotPublishingAnnouncement send: #notePublicationFinished: to: self. 
	self when: MDDSIsSubscribedAnnouncement send: #noteSubscription: to: self. 
	self when: MDDSIsNotSubscribedAnnouncement send: #noteSubscriptionFinished: to: self. 
! !

!MDDSDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/24/2014 17:56'!
note: anAnnouncement
	announcer announce: anAnnouncement.! !

!MDDSDomain methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/22/2014 21:51'!
protocols	
	^ protocols! !

!MDDSDomain methodsFor: 'announcer handling' stamp: 'SantiagoBragagnolo 10/24/2014 17:16'!
when: anEventSelector do: aBlockClosure 
	announcer weak when: anEventSelector do: aBlockClosure ! !

!MDDSDomain methodsFor: 'events-registering' stamp: 'SantiagoBragagnolo 10/24/2014 17:16'!
when: anEventSelector send: aMessage to: anObject
	announcer weak when: anEventSelector send: aMessage to: anObject! !

MDDSDomain subclass: #MDDSExternallyDefinedDomain
	instanceVariableNames: 'mirror'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSExternallyDefinedDomain commentStamp: 'SantiagoBragagnolo 10/22/2014 21:54' prior: 0!
ARemote domain is a domain known for being defined externally to the image.!

!MDDSExternallyDefinedDomain class methodsFor: 'constructor' stamp: 'SantiagoBragagnolo 10/22/2014 22:18'!
on: aMirror
	| domain |
	domain := self new. 
	domain mirror: aMirror.
	aMirror domain: domain.
	^ domain.! !

!MDDSExternallyDefinedDomain methodsFor: 'abstract' stamp: 'SantiagoBragagnolo 11/13/2014 20:02'!
createPublicationFor: aMDDSDomainParticipant with: aType
	^ mirror createPublicationFor: aMDDSDomainParticipant with: aType.! !

!MDDSExternallyDefinedDomain methodsFor: 'abstract' stamp: 'SantiagoBragagnolo 11/30/2014 15:27'!
destroy
	super destroy.
	mirror
		ifNotNil: [ 
			mirror destroy.
			mirror := nil ]! !

!MDDSExternallyDefinedDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/22/2014 21:53'!
isRegistered: aMDDSTopic
	^ mirror
		findTopicByName: aMDDSTopic name
		ifFound: [ :topic | topic type name = aMDDSTopic type name ]
		ifNone: [ false ]! !

!MDDSExternallyDefinedDomain methodsFor: 'abstract' stamp: 'SantiagoBragagnolo 11/14/2014 14:36'!
loadTypeDefinitionNamed: aName definedFromString: aStringDefinition
	^ mirror loadTypeDefinitionNamed: aName definedFromString: aStringDefinition! !

!MDDSExternallyDefinedDomain methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/11/2014 00:27'!
mirror
	^ mirror! !

!MDDSExternallyDefinedDomain methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/22/2014 22:17'!
mirror: aDomainMirror
	mirror := aDomainMirror.
	! !

!MDDSExternallyDefinedDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/23/2014 21:12'!
notePublication: aMDDSIsPublishingAnnouncement
	mirror notePublication: aMDDSIsPublishingAnnouncement! !

!MDDSExternallyDefinedDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/28/2014 17:11'!
notePublicationFinished: aMDDSIsNotPublishingAnnouncement
	mirror notePublicationFinished: aMDDSIsNotPublishingAnnouncement.
	(aMDDSIsNotPublishingAnnouncement publication) destroy.! !

!MDDSExternallyDefinedDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/23/2014 21:12'!
noteSubscription: aMDDSIsSubscribedAnnouncement
	mirror noteSubscription: aMDDSIsSubscribedAnnouncement! !

!MDDSExternallyDefinedDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/28/2014 17:12'!
noteSubscriptionFinished: aMDDSIsNotSubscribedAnnouncement 
	mirror noteSubscriptionFinished: aMDDSIsNotSubscribedAnnouncement.
	(aMDDSIsNotSubscribedAnnouncement subscription) destroy.! !

!MDDSExternallyDefinedDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/4/2014 19:39'!
obtainPort
	^ mirror obtainPort.! !

!MDDSExternallyDefinedDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 2/8/2015 12:24'!
participants
	^ mirror participants! !

!MDDSExternallyDefinedDomain methodsFor: 'abstract' stamp: 'SantiagoBragagnolo 11/18/2014 16:05'!
plainTypeDefinitionFor: aType
	^ mirror plainTypeDefinitionFor: aType! !

!MDDSExternallyDefinedDomain methodsFor: 'abstract' stamp: 'SantiagoBragagnolo 11/26/2014 20:42'!
registerTypeDefinition: aMDDSTypeDefinition
	^ mirror registerTypeDefinition: aMDDSTypeDefinition! !

!MDDSExternallyDefinedDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:17'!
subscriberFor: aTopic
	^ mirror subscriberFor: aTopic! !

!MDDSExternallyDefinedDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:17'!
topics
	^ mirror topics collect: #createTopic! !

!MDDSExternallyDefinedDomain methodsFor: 'abstract' stamp: 'SantiagoBragagnolo 11/19/2014 12:20'!
typeDefinition: typeName ifAbsent: aBlock
	^ mirror typeDefinition: typeName ifAbsent: aBlock! !

MDDSDomain subclass: #MDDSInternallyDefinedDomain
	instanceVariableNames: 'types portResolver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSInternallyDefinedDomain commentStamp: 'SantiagoBragagnolo 10/23/2014 23:00' prior: 0!
A MDDSInternallyDefinedDomain 

In this case all what goes to type definition and knowledge about existan topics, participants and its relations is defined in this image. !

!MDDSInternallyDefinedDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/13/2014 20:02'!
createPublicationFor: aMDDSDomainParticipant with: aType
	^ MDDSPublication publishing: aMDDSDomainParticipant with: aType marshaller.! !

!MDDSInternallyDefinedDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 12/1/2014 16:03'!
destroy
	super destroy.
	types
		ifNotNil: [ 
			types unload.
			types := nil ]! !

!MDDSInternallyDefinedDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/19/2014 12:27'!
initialize
	super initialize.
	types := MDDSTypeLoader new.
	portResolver  := MDDSPortResolver obtain! !

!MDDSInternallyDefinedDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/22/2014 23:41'!
isRegistered: aMDDSTopic
	^ createdTopics at: aMDDSTopic name ifPresent: [ true ] ifAbsent: [false].
	! !

!MDDSInternallyDefinedDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/14/2014 14:36'!
loadTypeDefinitionNamed: aName definedFromString: aStringDefinition
	^ types loadTypeDefinitionNamed: aName definedFromString: aStringDefinition! !

!MDDSInternallyDefinedDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/28/2014 17:21'!
notePublication: aMDDSIsPublishingAnnouncement
	| publication reading writing |
	publication := aMDDSIsPublishingAnnouncement publication.
	aMDDSIsPublishingAnnouncement topic subscriber subscriptions
		do: [ :subscription | 
			reading := MDDSReadingReferenceConnection dispatchingTo: aMDDSIsPublishingAnnouncement topic subscriber.
			reading participant: aMDDSIsPublishingAnnouncement publication participant.
			writing := MDDSWritingReferenceConnection linkedTo: reading.
			writing participant: subscription participant.
			publication register: writing.
			subscription registerConnection: reading ]! !

!MDDSInternallyDefinedDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/28/2014 17:28'!
notePublicationFinished: aMDDSIsNotPublishingAnnouncement
	aMDDSIsNotPublishingAnnouncement topic subscriber subscriptions
		do: [ :s | s connections removeAll: (s connections select: [ :c | c participant = aMDDSIsNotPublishingAnnouncement participant ]) ]! !

!MDDSInternallyDefinedDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/28/2014 17:20'!
noteSubscription: aMDDSIsSubscribedAnnouncement
	| subscription reading writing |
	subscription := aMDDSIsSubscribedAnnouncement subscription.
	aMDDSIsSubscribedAnnouncement topic publisher publications
		do: [ :publication | 
			reading := MDDSReadingReferenceConnection dispatchingTo: aMDDSIsSubscribedAnnouncement subscriber.
			reading participant: publication participant.
			writing := MDDSWritingReferenceConnection linkedTo: reading.
			writing participant: aMDDSIsSubscribedAnnouncement subscription participant.
			publication register: writing.
			subscription registerConnection: reading ]! !

!MDDSInternallyDefinedDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/28/2014 17:19'!
noteSubscriptionFinished: aMDDSIsNotSubscribedAnnouncement
	aMDDSIsNotSubscribedAnnouncement topic publisher publications
		do: [ :p | p connections removeAll: (p connections select: [ :c | c participant = aMDDSIsNotSubscribedAnnouncement participant] ) ].! !

!MDDSInternallyDefinedDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/24/2014 12:01'!
obtainPort
	^ portResolver obtainPort.! !

!MDDSInternallyDefinedDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/18/2014 16:05'!
plainTypeDefinitionFor: aType
	^ types plainTypeDefinitionFor: aType! !

!MDDSInternallyDefinedDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/13/2014 22:33'!
registerTypeDefinition: aMDDSTypeDefinition
	^ types registerTypeDefinition: aMDDSTypeDefinition! !

!MDDSInternallyDefinedDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/22/2014 23:40'!
topics
	^ createdTopics values! !

!MDDSInternallyDefinedDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/19/2014 12:20'!
typeDefinition: typeName ifAbsent: aBlock
	^ types typeDefinition: typeName ifAbsent: aBlock! !

!MDDSProtoDomain methodsFor: 'abstract' stamp: 'SantiagoBragagnolo 9/11/2014 00:31'!
asString
	^ 'DDS-Domain'! !

!MDDSProtoDomain methodsFor: 'querying' stamp: 'SantiagoBragagnolo 10/20/2014 22:15'!
findTopicByName: aName
	^ self findTopicByName: aName ifNone: [ MDDSError signal: 'There is not topic named ' , aName ]! !

!MDDSProtoDomain methodsFor: 'querying' stamp: 'SantiagoBragagnolo 10/20/2014 22:15'!
findTopicByName: aName ifFound: aFoundBlock ifNone: aBlock
	^ self topics detect: [ :t | t name = aName ] ifFound: aFoundBlock ifNone: aBlock! !

!MDDSProtoDomain methodsFor: 'querying' stamp: 'SantiagoBragagnolo 10/20/2014 22:15'!
findTopicByName: aName ifNone: aBlock
	^ self topics detect: [ :t | t name = aName ] ifNone: aBlock! !

!MDDSProtoDomain methodsFor: 'abstract' stamp: 'SantiagoBragagnolo 12/1/2014 13:49'!
isTypeDefined: aTypeName
	self typeDefinition: aTypeName ifAbsent: [ ^ false ].
	^ true.! !

!MDDSProtoDomain methodsFor: 'abstract' stamp: 'SantiagoBragagnolo 11/14/2014 14:36'!
loadTypeDefinitionNamed: aName definedFromString: aStringDefinition
	self subclassResponsibility! !

!MDDSProtoDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/23/2014 21:11'!
notePublication: aMDDSIsPublishingAnnouncement
! !

!MDDSProtoDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/23/2014 21:11'!
notePublicationFinished: aMDDSIsNotPublishingAnnouncement 
! !

!MDDSProtoDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/23/2014 21:11'!
noteSubscription: aMDDSIsSubscribedAnnouncement 
! !

!MDDSProtoDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/23/2014 21:11'!
noteSubscriptionFinished: aMDDSIsNotSubscribedAnnouncement ! !

!MDDSProtoDomain methodsFor: 'abstract' stamp: 'SantiagoBragagnolo 9/11/2014 00:31'!
participants
	^ self subclassResponsibility ! !

!MDDSProtoDomain methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/18/2014 16:05'!
plainTypeDefinitionFor: aType
	self subclassResponsibility.! !

!MDDSProtoDomain methodsFor: 'abstract' stamp: 'SantiagoBragagnolo 10/20/2014 22:15'!
subscriberFor: aTopic
	^ MDDSSubscriber domain: self named: aTopic name , '-subscriber' on: aTopic! !

!MDDSProtoDomain methodsFor: 'abstract' stamp: 'SantiagoBragagnolo 10/20/2014 22:15'!
topics
	self subclassResponsibility! !

!MDDSProtoDomain methodsFor: 'abstract' stamp: 'SantiagoBragagnolo 11/19/2014 12:19'!
typeDefinition: aTypeName
	^ self typeDefinition: aTypeName ifAbsent: [  self error: ' There is no type named ' , aTypeName ]! !

!MDDSProtoDomain methodsFor: 'abstract' stamp: 'SantiagoBragagnolo 11/19/2014 12:19'!
typeDefinition: aTypeName ifAbsent: aBlock
	^self subclassResponsibility ! !

Object subclass: #MDDSProtocol
	instanceVariableNames: 'encoder decoder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSProtocol commentStamp: 'SantiagoBragagnolo 10/3/2014 16:12' prior: 0!
A protocol is a reification of the protocol it self. 
The protocol in a DDS, where connections are one way only is the combination of:
	 # The connection handshake.
	 # The way to encode each type.
	 # The way each type is structured.
By example, the TCPROS protocol
	# The connection hand shake defines the quality of service and is a two ways hand shake.
	# The way to encode each type is the standart one  (Defined in MDDSEncoder/MDDSDecoder)
	# The way to structure the data is the standar one (Defined in MDDSBaseTypeMarshaller hierarchy)!

MDDSProtocol subclass: #MDDSHeaderProtocol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSHeaderProtocol commentStamp: 'SantiagoBragagnolo 10/6/2014 18:30' prior: 0!
The header protocol is a protocol that suits the needs of the header messanging in between connections during the handhshake of a connection.!

!MDDSHeaderProtocol methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/3/2014 15:41'!
initializeDecoder: aDecoder with: aTypeMarshaller
	^ aDecoder! !

!MDDSProtocol class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/3/2014 16:00'!
encoding: anEncoder decoding: aDecoder 
	^ self new encoder: anEncoder ; decoder: aDecoder ; yourself.
	! !

!MDDSProtocol methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:17'!
connect: aMDDSConnectionPetition
	self subclassResponsibility! !

!MDDSProtocol methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:17'!
createDecoderOn: aStream with: aTypeMarshaller
	| aDecoder |
	aDecoder := decoder on: aStream.
	self initializeDecoder: aDecoder with: aTypeMarshaller.
	^ aDecoder! !

!MDDSProtocol methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:17'!
createSocketForlistenOn: aPort
	self subclassResponsibility! !

!MDDSProtocol methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:18'!
decoder: aDecoder
	decoder := aDecoder! !

!MDDSProtocol methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:18'!
dump: aValue with: aTypeMarshaller
	| stream anEncoder buffer valueSize |
	valueSize := aTypeMarshaller dataTypeSizeFor: aValue.
	buffer := ByteArray new: valueSize + 4.
	stream := WriteStream on: buffer.
	anEncoder := encoder on: stream.
	anEncoder encodeInt32: valueSize.
	aTypeMarshaller serialize: aValue into: anEncoder.
	^ buffer! !

!MDDSProtocol methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:18'!
encoder: anEncoder
	encoder := anEncoder! !

!MDDSProtocol methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:18'!
initializeDecoder: aDecoder with: aTypeMarshaller
	| size |
	size := aDecoder nextEncodedUint32.
	(aTypeMarshaller isAPossibleSize: size)
		ifFalse: [ MDDSError signal: ' Unexpected Value' ].
	size > 20000000
		ifTrue: [ 
			"too long, maybe is a problem in buffer. "
			aDecoder resetBuffers.
			self error: 'Warning. trying to load ' , size asString , ' bytes' ].
	^ aDecoder! !

!MDDSProtocol methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:18'!
load: aByteArray with: aTypeMarshaler
	^ self loadStream: (ReadStream on: aByteArray) with: aTypeMarshaler! !

!MDDSProtocol methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:18'!
loadStream: aStream with: aTypeMarshaler
	^ aTypeMarshaler decode: (self createDecoderOn: aStream with: aTypeMarshaler)! !

!MDDSProtocol methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/20/2014 22:18'!
name
	^ self subclassResponsibility! !

Object subclass: #MDDSPublication
	instanceVariableNames: 'participant marshaller connections connectionOffer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSPublication commentStamp: 'SantiagoBragagnolo 10/6/2014 18:32' prior: 0!
A publication is the reification of the relation in between a participant that publishes and the participatns that consumes the data.

Each publication has n sockets, one per protocol.
!

!MDDSPublication class methodsFor: 'constructor' stamp: 'SantiagoBragagnolo 11/13/2014 23:22'!
publishing: aMDDSDomainParticipant with: aMarshaller
	^ self new participant: aMDDSDomainParticipant; marshaller: aMarshaller; yourself. ! !

!MDDSPublication methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/27/2014 12:47'!
connections
	^ connections! !

!MDDSPublication methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 11/13/2014 20:55'!
destroy
	! !

!MDDSPublication methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/27/2014 12:47'!
initialize
	connections := Set new! !

!MDDSPublication methodsFor: 'testing' stamp: 'SantiagoBragagnolo 10/20/2014 22:18'!
isPublishing: aMDDSDomainParticipant
	^ participant = aMDDSDomainParticipant! !

!MDDSPublication methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/6/2014 18:21'!
marshaller
	^ marshaller! !

!MDDSPublication methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/6/2014 18:21'!
marshaller: aTypeMarshaller
	marshaller := aTypeMarshaller! !

!MDDSPublication methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/13/2014 23:28'!
noteIsNotRegisteredAnymore
	connections do: #destroy.
	connections removeAll.
	marshaller := nil.
	connectionOffer := nil! !

!MDDSPublication methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 11/13/2014 21:08'!
noteIsRegisteredIn: aPublisher
	connectionOffer := MDDSConnectionOffer publisher: aPublisher participant: participant! !

!MDDSPublication methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/13/2014 15:54'!
participant
	^ participant! !

!MDDSPublication methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/20/2014 22:18'!
participant: aMDDSDomainParticipant
	participant := aMDDSDomainParticipant! !

!MDDSPublication methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/27/2014 12:46'!
publish: aBlock
	connections size > 0
		ifTrue: [ 
			| value |
			value := self marshaller newInstance.
			aBlock value: value.
			self publishValue: value ]! !

!MDDSPublication methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/27/2014 13:03'!
publishValue: aValue
	| deathConnections |
	deathConnections := Set new.
	connections
		do: [ :writingConnection | 
			[ writingConnection write: aValue with: self marshaller ]
				on: Error
				do: [ 
					writingConnection isDead
						ifTrue: [ deathConnections add: writingConnection ] ] ].
	connections removeAll: deathConnections! !

!MDDSPublication methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/27/2014 23:32'!
register: aWritingConnection
	connections add: aWritingConnection! !

Object subclass: #MDDSSubscription
	instanceVariableNames: 'onRead onFailure onStop participant connections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

MDDSSubscription class
	instanceVariableNames: 'defaultBlock failBlock'!

!MDDSSubscription commentStamp: 'SantiagoBragagnolo 9/11/2014 22:57' prior: 0!
A MDDSSubscription is a conection in between topic readings and a set of callbacks. !

MDDSSubscription class
	instanceVariableNames: 'defaultBlock failBlock'!

!MDDSSubscription class methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/11/2014 22:55'!
defaultBlock
	^ defaultBlock ifNil: [ defaultBlock:=[  ]].! !

!MDDSSubscription class methodsFor: 'constructor' stamp: 'SantiagoBragagnolo 10/27/2014 19:17'!
defaultForParticipant: aParticipant
	^ self forParticipant: aParticipant onRead: self onRead onFailure: self onFailure onStop: self onStop.! !

!MDDSSubscription class methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/18/2014 17:27'!
failBlock
	^ failBlock ifNil: [ failBlock := [: e| Transcript open; show: e messageText; cr. ]].! !

!MDDSSubscription class methodsFor: 'constructor' stamp: 'SantiagoBragagnolo 9/12/2014 19:21'!
forParticipant: aParticipant onRead: onRead onFailure: onFailure onStop: onStop 
	^ self new participant: aParticipant; onRead:  onRead; onFailure: onFailure; onStop: onStop ; yourself.! !

!MDDSSubscription class methodsFor: 'default-configuration' stamp: 'SantiagoBragagnolo 10/18/2014 17:27'!
onFailure
	^ self failBlock.! !

!MDDSSubscription class methodsFor: 'default-configuration' stamp: 'SantiagoBragagnolo 9/11/2014 22:55'!
onRead
	^ self defaultBlock .! !

!MDDSSubscription class methodsFor: 'default-configuration' stamp: 'SantiagoBragagnolo 9/11/2014 22:55'!
onStop
	^ self defaultBlock .! !

!MDDSSubscription methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/27/2014 21:56'!
connections
	^ connections 
	! !

!MDDSSubscription methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/28/2014 00:06'!
destroy
	connections do: #destroy.
	connections removeAll.
	! !

!MDDSSubscription methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/27/2014 21:57'!
dispatch: aReceivedMessage
	self noteNewMessage: aReceivedMessage.! !

!MDDSSubscription methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/27/2014 22:12'!
initialize
	super initialize.
	connections := Set new.! !

!MDDSSubscription methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 3/5/2015 15:52'!
noteError: anError
	onFailure cull: anError messageText.! !

!MDDSSubscription methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/3/2014 12:34'!
noteFailure: aFailure
	onFailure cull: aFailure! !

!MDDSSubscription methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/2/2014 15:43'!
noteNewMessage: aMessage
	onRead value: aMessage! !

!MDDSSubscription methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/2/2014 15:43'!
noteStop
	onStop value.! !

!MDDSSubscription methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 11/23/2014 23:47'!
noteStop: aConnection
	connections remove: aConnection.
! !

!MDDSSubscription methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/11/2014 23:03'!
onFailure
	^ onFailure! !

!MDDSSubscription methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/11/2014 22:54'!
onFailure: aBlockClosure 
	onFailure := aBlockClosure ! !

!MDDSSubscription methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/11/2014 23:03'!
onRead
	^ onRead! !

!MDDSSubscription methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/11/2014 22:54'!
onRead: aBlockClosure 
	onRead := aBlockClosure! !

!MDDSSubscription methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/11/2014 23:03'!
onStop
	^ onStop! !

!MDDSSubscription methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/11/2014 22:54'!
onStop: aBlockClosure 
	onStop := aBlockClosure ! !

!MDDSSubscription methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/12/2014 19:20'!
participant
	^ participant.! !

!MDDSSubscription methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/12/2014 19:20'!
participant: aParticipant
	participant := aParticipant! !

!MDDSSubscription methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/27/2014 22:18'!
registerConnection: aConnection
	" Now i should make a difference between subscriptions in terms of participant and where the connection is coming from. "

	connections add: aConnection.
	aConnection messageDispatcher: self.
	aConnection noteIsRegistered.! !

Object subclass: #MDDSTimestamp
	uses: TEquality
	instanceVariableNames: 'timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-TypesMarshalling'!

!MDDSTimestamp commentStamp: '<historical>' prior: 0!
A PhaROSTimestamp is wrapper that makes easy to make the conversions between ROS and pharo!

MDDSTimestamp class
	uses: TEquality classTrait
	instanceVariableNames: ''!

!MDDSTimestamp class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/16/2014 20:40'!
fromUnixTime: anAmountOfSeconds  nanoSeconds: anAmountOfNSeconds 
	^ super new timestamp: ((DateAndTime fromUnixTime: anAmountOfSeconds)  + (Time seconds: 0 nanoSeconds: anAmountOfNSeconds ));
				  yourself.! !

!MDDSTimestamp class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/16/2014 20:40'!
new
	^ super new timestamp:( DateAndTime fromUnixTime: 0) ; yourself .! !

!MDDSTimestamp class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/16/2014 20:40'!
now
	^ super new timestamp: DateAndTime now ; yourself .! !

!MDDSTimestamp methodsFor: 'operations' stamp: 'SantiagoBragagnolo 9/15/2014 20:12'!
+ aDuration
	^ MDDSTimestamp new timestamp: timestamp + aDuration ; yourself.! !

!MDDSTimestamp methodsFor: 'operations' stamp: 'SantiagoBragagnolo 6/12/2013 14:03'!
- aDateAndTime
	^ timestamp - aDateAndTime asDateAndTime.! !

!MDDSTimestamp methodsFor: 'operations' stamp: 'SantiagoBragagnolo 6/12/2013 14:08'!
< aDateAndTime
	^ timestamp < aDateAndTime asDateAndTime.! !

!MDDSTimestamp methodsFor: 'comparing' stamp: ''!
= anObject 
	self species = anObject species ifFalse: [^false].
	^self valuesToCompareForEquality = anObject valuesToCompareForEquality! !

!MDDSTimestamp methodsFor: 'operations' stamp: 'SantiagoBragagnolo 6/12/2013 14:08'!
> aDateAndTime
	^ timestamp > aDateAndTime asDateAndTime.! !

!MDDSTimestamp methodsFor: 'converting' stamp: 'SantiagoBragagnolo 6/13/2013 11:54'!
asDateAndTime
	^ timestamp! !

!MDDSTimestamp methodsFor: 'comparing' stamp: 'SantiagoBragagnolo 1/23/2013 14:37'!
closeTo: anOtherPhaROSTimeStamp
	^ timestamp = anOtherPhaROSTimeStamp timestamp.
	! !

!MDDSTimestamp methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/16/2014 20:39'!
fromUnixTime: anAmountOfSeconds  nanoSeconds: anAmountOfNSeconds 
	^ super new timestamp: ((DateAndTime fromUnixTime: anAmountOfSeconds)  + (Time seconds: 0 nanoSeconds: anAmountOfNSeconds ));
				  yourself.! !

!MDDSTimestamp methodsFor: 'comparing' stamp: ''!
hash
	^self valuesToCompareForEquality inject: self species hash into: [:hash :comparisonValue|
		(hash bitXor: comparisonValue hash) hashMultiply]
! !

!MDDSTimestamp methodsFor: 'converting' stamp: 'SantiagoBragagnolo 1/23/2013 13:10'!
nanoSeconds
	^ timestamp nanoSecond.! !

!MDDSTimestamp methodsFor: 'simple instance creation' stamp: 'SantiagoBragagnolo 1/23/2013 13:21'!
nanoSeconds: anAmountOfNSeconds 
	timestamp nanoSeconds: anAmountOfNSeconds ! !

!MDDSTimestamp methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/16/2014 20:39'!
new
	^ super new timestamp:( DateAndTime fromUnixTime: 0) ; yourself .! !

!MDDSTimestamp methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/16/2014 20:39'!
now
	^ super new timestamp: DateAndTime now ; yourself .! !

!MDDSTimestamp methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 2/1/2013 11:39'!
seconds
	^ timestamp asUnixTime .! !

!MDDSTimestamp methodsFor: 'private' stamp: 'SantiagoBragagnolo 1/23/2013 13:21'!
seconds: anAmountOfSeconds
	timestamp seconds: anAmountOfSeconds.! !

!MDDSTimestamp methodsFor: 'private' stamp: 'SantiagoBragagnolo 1/23/2013 19:06'!
seconds: anAmountOfSeconds  nanoSeconds: anAmountOfNSeconds 
	timestamp := (DateAndTime fromUnixTime: anAmountOfSeconds) + (Time seconds: 0 nanoSeconds: anAmountOfNSeconds ).
	^ timestamp.! !

!MDDSTimestamp methodsFor: 'converting' stamp: 'SantiagoBragagnolo 2/1/2013 14:18'!
secondsUTC
	^ timestamp asUnixTime - (timestamp offset asSeconds).! !

!MDDSTimestamp methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 1/23/2013 14:37'!
timestamp 
	^ timestamp.! !

!MDDSTimestamp methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 1/23/2013 13:03'!
timestamp: aDateAndTime
	timestamp := aDateAndTime.
	! !

Object subclass: #MDDSTypeBuilder
	instanceVariableNames: 'definition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-TypesDefinition'!

!MDDSTypeBuilder commentStamp: '<historical>' prior: 0!
PhaROSMessageTypeBuilder  named: #blaa package: #ble defined: { 
		UInt8 named: #bla .
		String named: #sarasa .
		FixedArray named: #lala sized: 30 ofType: UInt16.
		ROSType definedBy: 'std_msgs/Header' named: #header.
	}.

Is in charge of generating Ros definition of a type, Pharo definition of the type, and generate the related class in pharo. !

!MDDSTypeBuilder class methodsFor: 'instance creation' stamp: 'SantiagoBragagnolo 9/19/2014 18:51'!
defined: aDefinition

	^ self new  definition: aDefinition ; 
				yourself.! !

!MDDSTypeBuilder methodsFor: 'related class building' stamp: 'SantiagoBragagnolo 10/20/2014 22:36'!
buildDTOClass
	| class |
	class := MDDSAbstractDTO
		subclass: self classname asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'MDDSGenerated'.
	self installMethodsIn: class.
	self installConstantsIn: class.
	^ class! !

!MDDSTypeBuilder methodsFor: 'building' stamp: 'SantiagoBragagnolo 10/20/2014 22:36'!
buildTypeMarshaller
	^ (MDDSCompositeType named: self name definedBy: definition fields withConstants: definition constants)
		relatedClass: self relatedClass;
		yourself! !

!MDDSTypeBuilder methodsFor: 'related class building' stamp: 'SantiagoBragagnolo 10/20/2014 22:36'!
classname
	^ (self name copyReplaceAll: '/' with: '_') capitalized! !

!MDDSTypeBuilder methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 2/8/2014 12:03'!
definition
	^ definition! !

!MDDSTypeBuilder methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 2/8/2014 11:20'!
definition: anArrayOfAssociations
	definition := anArrayOfAssociations! !

!MDDSTypeBuilder methodsFor: 'proto' stamp: 'SantiagoBragagnolo 10/3/2014 15:45'!
forPhaROSTyping
	^ self buildTypeMarshaller  ! !

!MDDSTypeBuilder methodsFor: 'related class building' stamp: 'SantiagoBragagnolo 10/20/2014 22:37'!
installConstantsIn: aClass
	self definition constants do: [ :constant | aClass class compile: constant classAccessor ]! !

!MDDSTypeBuilder methodsFor: 'related class building' stamp: 'SantiagoBragagnolo 10/20/2014 22:37'!
installMethodsIn: aClass
	self definition fields
		do: [ :field | 
			aClass compile: field setter.
			aClass compile: field getter.
			field hasToInstallHelper
				ifTrue: [ aClass compile: field helper ] ].
	aClass
		compile:
			((self definition fields collect: #initializer)
				inject: 'initialize' , String crlf , String tab , 'super initialize.' , String crlf
				into: [ :acc :line | acc , line ])! !

!MDDSTypeBuilder methodsFor: 'proto' stamp: 'pharos 3/1/2014 11:25'!
isServiceType
	^ false! !

!MDDSTypeBuilder methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/19/2014 18:53'!
name
	^  definition name.! !

!MDDSTypeBuilder methodsFor: 'building' stamp: 'SantiagoBragagnolo 10/20/2014 22:37'!
relatedClass
	^ Smalltalk at: self classname asSymbol ifAbsent: [ self buildDTOClass ]! !

!MDDSTypeBuilder methodsFor: 'converting' stamp: 'SantiagoBragagnolo 2/11/2014 14:18'!
rosdefinition
	^ definition rosdefinition.! !

!MDDSTypeBuilder methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/19/2014 18:52'!
shortName
	^ self name! !

Object subclass: #MDDSTypeDefinition
	instanceVariableNames: 'definition name md5sum'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-TypesDefinition'!

!MDDSTypeDefinition commentStamp: '<historical>' prior: 0!
A PhaROSTypeDefinition is a reification of set of fields and constants. !

!MDDSTypeDefinition class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/19/2014 18:49'!
message
	^ MDDSTypeDefinition.! !

!MDDSTypeDefinition class methodsFor: 'instance creation' stamp: 'SantiagoBragagnolo 9/19/2014 18:50'!
named: aTypeName defined: anArrayOfDefinitions
	^ self new name: aTypeName;  definition: anArrayOfDefinitions; yourself! !

!MDDSTypeDefinition methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 10/20/2014 22:38'!
at: aName
	^ definition detect: [ :def | def name = aName ]! !

!MDDSTypeDefinition methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 2/8/2014 12:13'!
atPosition: anIndex
	^ definition at: anIndex! !

!MDDSTypeDefinition methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/26/2014 20:56'!
beRegisteredBy: aTypeLoader
	self constants do: [ : constant | constant typeDefinition beRegisteredBy: aTypeLoader  ].
	self fields do: [ :field | field typeDefinition beRegisteredBy: aTypeLoader  ].
	^ aTypeLoader privateRegisterTypeDefinition: self.
	! !

!MDDSTypeDefinition methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/19/2014 18:26'!
constant: aFieldName 
	^ self findConstant: aFieldName ifNone: [  MDDSError signal:  aFieldName, ' is not a valid field ' ].! !

!MDDSTypeDefinition methodsFor: 'constants' stamp: 'SantiagoBragagnolo 2/8/2014 12:11'!
constants
	^ definition select: #isConstant! !

!MDDSTypeDefinition methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 2/8/2014 12:04'!
definition: anArrayOfDefinitions
	definition := anArrayOfDefinitions ! !

!MDDSTypeDefinition methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/17/2014 23:12'!
field: aFieldName 
	^ self findField: aFieldName ifNone: [  MDDSError signal:  aFieldName, ' is not a valid field ' ].! !

!MDDSTypeDefinition methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 2/8/2014 12:11'!
fields
	^ definition select: #isField! !

!MDDSTypeDefinition methodsFor: 'find' stamp: 'SantiagoBragagnolo 9/19/2014 18:25'!
findConstant: aFieldName ifNone: aBlockClosure 
	^ (definition select:#isConstant) detect: [ : f | f name = aFieldName  ] ifNone: aBlockClosure .! !

!MDDSTypeDefinition methodsFor: 'find' stamp: 'SantiagoBragagnolo 9/19/2014 18:25'!
findField: aFieldName ifNone: aBlockClosure 
	^ (definition select:#isField) detect: [ : f | f name = aFieldName  ] ifNone: aBlockClosure .! !

!MDDSTypeDefinition methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/1/2014 23:45'!
md5sum
	^ md5sum! !

!MDDSTypeDefinition methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/1/2014 22:55'!
md5sum:	aString
		md5sum := aString! !

!MDDSTypeDefinition methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/19/2014 18:53'!
name
	^ name! !

!MDDSTypeDefinition methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/19/2014 18:53'!
name: aName
	name := aName! !

!MDDSTypeDefinition methodsFor: 'converting' stamp: 'SantiagoBragagnolo 9/19/2014 19:45'!
rosdefinition
	^ definition inject: '' into: [ :acc :item | acc, item rosdefinition, String lf  ].! !

!MDDSTypeDefinition methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/19/2014 18:55'!
typeBuilder
	^ MDDSTypeBuilder defined: self.! !

!MDDSTypeDefinition methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 2/13/2015 22:07'!
typeName
	^ name! !

Object subclass: #MDDSTypeLoader
	instanceVariableNames: 'registry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS-Kernel'!

!MDDSTypeLoader commentStamp: 'SantiagoBragagnolo 11/17/2014 16:20' prior: 0!
A MDDSTypeLoder in an object for loading types format for connections.!

!MDDSTypeLoader methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/13/2014 22:20'!
initialize
	registry := Dictionary new.! !

!MDDSTypeLoader methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/19/2014 12:14'!
loadTypeDefinitionNamed: aName definedFromString: aStringDefinition
	| definition |
	definition := STON reader
		on: aStringDefinition readStream;
		next.
	self registerTypeDefinition: definition.
	^ definition! !

!MDDSTypeLoader methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/18/2014 23:01'!
plainTypeDefinitionFor: aType
	
	^ String
		streamContents: [ :stream | 
			STON writer
				on: stream;
				nextPut: (self typeDefinition: aType name) ]! !

!MDDSTypeLoader methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/26/2014 20:53'!
privateRegisterTypeDefinition: aMDDSTypeDefinition

	registry at: aMDDSTypeDefinition name put: aMDDSTypeDefinition.
	^aMDDSTypeDefinition! !

!MDDSTypeLoader methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/26/2014 20:53'!
registerTypeDefinition: aMDDSTypeDefinition
	^ aMDDSTypeDefinition beRegisteredBy: self.
	! !

!MDDSTypeLoader methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/13/2014 22:24'!
typeDefinition: aTypeId
	^ self typeDefinition: aTypeId ifAbsent: [ self error: ' There is no type named ' , aTypeId]! !

!MDDSTypeLoader methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/19/2014 12:19'!
typeDefinition: aTypeName ifAbsent: aBlock
	^ registry at: aTypeName ifAbsent: aBlock.! !

!MDDSTypeLoader methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 11/28/2014 12:41'!
unload
	registry removeAll.! !

Object subclass: #MetaDDSIdeas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaDDS'!

!MetaDDSIdeas commentStamp: 'SantiagoBragagnolo 10/17/2014 15:58' prior: 0!
Testing:

	TODO: Test that all what is mirror is mirror and what is concrete it is actually concrete.
	

Implement

	Local master - just for pharo. 
	Local master - just for pharo - ros compatible. !

!MetaDDSIdeas methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 2/8/2015 17:32'!
publisher
"SUBSCRIBER"

| domain mirror participant type adhoc subscription in |
domain := MDDSExternallyDefinedDomain onROS: 'http://127.0.0.1:11311/'.
mirror := domain mirror . 


participant := MDDSDomainParticipant domain: domain name: 'adhoc-participant' ip: '127.0.0.1'.

type :=  MDDSTypeDescriptor domain: domain name: 'std_msgs/Int16'.

adhoc := (MDDSTopicDescriptor domain: domain name: '/adhoc'  type: type) createTopic.

domain addProtocol: (DDSTCPProtocol encoding: MDDSEncoder  decoding: MDDSDecoder).


subscription := adhoc subscriber forParticipant: participant onRead: [ 
 : packet |
	self halt. 	
 ].


in := DDSParticipantProxy on: 'http://127.0.0.1:10000'. 


in proxy requestFor: ' name 'theTopic: '/adhoc' withProtocol: { 'TCPROS'}. 


type := subscription := mirror := domain := participant := adhoc := nil.

XMLRPCService stopAll.

TKTRunner allSubInstances do: #cancel.


MDDSPublication allInstances
 do:#stopPublishing.
DDSPublicationServer allInstances do:#stop.
DDSSParticipantServer allInstances do:#unserve.
Socket allInstances do: #destroy.

MDDSEntity allSubInstances
 do: [ :e | e domain: nil].

MDDSReadingNetworkConnection allInstances 
do: #destroy.


30 timesRepeat: [  Smalltalk garbageCollect  ].

! !

!MetaDDSIdeas methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 2/8/2015 17:32'!
subscriber
"SUBSCRIBER"

| domain mirror participant type adhoc subscription in |
domain := MDDSExternallyDefinedDomain onROS: 'http://127.0.0.1:11311/'.
mirror := domain mirror . 


participant := MDDSDomainParticipant domain: domain name: 'adhoc-participant' ip: '127.0.0.1'.

type :=  MDDSTypeDescriptor domain: domain name: 'std_msgs/Int16'.

adhoc := (MDDSTopicDescriptor domain: domain name: '/adhoc'  type: type) createTopic.

domain addProtocol: (DDSTCPProtocol encoding: MDDSEncoder  decoding: MDDSDecoder).


subscription := adhoc subscriber forParticipant: participant onRead: [ 
 : packet |
	self halt. 	
 ].


in := DDSParticipantProxy on: 'http://127.0.0.1:10000'. 


in proxy requestFor: ' name 'theTopic: '/adhoc' withProtocol: { 'TCPROS'}. 


type := subscription := mirror := domain := participant := adhoc := nil.

XMLRPCService stopAll.

TKTRunner allSubInstances do: #cancel.





MDDSPublication allInstances
 do:#stopPublishing.
DDSPublicationServer allInstances do:#stop.
DDSSParticipantServer allInstances do:#unserve.
Socket allInstances do: #destroy.

MDDSEntity allSubInstances
 do: [ :e | e domain: nil].

MDDSReadingNetworkConnection allInstances 
do: #destroy.


30 timesRepeat: [  Smalltalk garbageCollect  ].

! !

!MetaDDSIdeas methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/19/2014 21:21'!
ws
| mirror domain participant adhoc |

mirror := MDDSRemoteDomainMirror onROS: 'http://dora:11311/'.
domain := mirror domain. 
participant := MDDSDomainParticipant domain: domain name: 'adhoc-participant'.
adhoc := MDDSTopic domain: domain name: '/adhoc'  type: 'std_msgs/Int16'. 
adhoc subscriber forParticipant: participant onRead: [ 
 : packet |
	self halt. 	
 ]


MDDSProtoDomain  allSubInstances.
XMLRPCService stop: 9999.
20 timesRepeat: [  Smalltalk garbageCollect  ].
! !

!Object class methodsFor: '*MetaDDS' stamp: 'NouryBouraqadi 8/21/2014 14:45'!
allInstVarNamesForEqualityComparison
	^self superclass allInstVarNamesForEqualityComparison, self instVarNamesForEqualityComparison! !

!Object class methodsFor: '*MetaDDS' stamp: 'NouryBouraqadi 8/21/2014 14:44'!
instVarNamesForEqualityComparison
	^self instVarNames! !

!Object methodsFor: '*MetaDDS' stamp: 'NouryBouraqadi 8/21/2014 14:44'!
instVarNamesForEqualityComparison
	^self class allInstVarNamesForEqualityComparison! !

!Object methodsFor: '*MetaDDS' stamp: 'NouryBouraqadi 8/21/2014 14:36'!
valuesToCompareForEquality
	^self instVarNamesForEqualityComparison collect: [:ivName|
		self instVarNamed: ivName]! !
MDDSBaseTypeMarshaller initialize!
